program Pretvarjanje; { RTK 1989.2.3 }
type Polje = packed array[1..15] of char;

procedure Pretvori(var Stevilo: Polje; IzOsnove, VOsnovo: integer; var Dolzina: integer); 
const Stevke = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var i, T, Vrednost: integer; 
begin
  { Izraunajmo vrednost, ki jo predstavlja niz Stevilo. }
  Vrednost := 0; 
  for i := 1 to Dolzina do begin 
    T := 0; { Katero tevko predstavlja znak Stevilo[i]? }  
    while (T < IzOsnove) and (Stevke[T + 1] <> Stevilo[i]) do 
      T := T + 1; 
    if T >= IzOsnove then 
      begin WriteLn('Neveljavna tevka: ', Stevilo[i]); T := 0 end;
    Vrednost := Vrednost * IzOsnove + T; 
  end; {for}
  { Koliko tevk bo imelo to tevilo v zapisu z osnovo VOsnovo? }
  Dolzina := 0; 
  T := Vrednost; 
  repeat
    T := T div VOsnovo; 
    Dolzina := Dolzina + 1; 
  until T = 0;
  { V niz Stevilo vpiimo predstavitev tevila Vrednost z osnovo VOsnovo. }
  for i := Dolzina downto 1 do begin 
    Stevilo[i] := Stevke[(Vrednost mod VOsnovo) + 1]; 
    Vrednost := Vrednost div VOsnovo; 
  end; {for}
end; {Pretvori} 

{ Nakljuno izbrano tevilo stokrat pretvori
  v nakljuno izbrano bazo in na koncu nazaj v
  desetiko.  Nato preveri, e je tevilo enako
  kot na zaetku. }
procedure Test;
var 
  S: string; P: Polje; D: integer;
  i, Vrednost, NovaVrednost, Baza, NovaBaza: integer;
begin
  Vrednost := Random(10000); NovaBaza := 10;
  Str(Vrednost, S); 
  P := S; D := Length(S);
  for i := 1 to 100 do begin
    Baza := NovaBaza;
    NovaBaza := 2 + Random(35);
    Pretvori(P, Baza, NovaBaza, D);
  end; {for i}
  Pretvori(P, NovaBaza, 10, D);
  S := Copy(P, 1, D); Val(S, NovaVrednost, i);
  Assert(i = 0); 
  Assert(Vrednost = NovaVrednost);
end; {Test}

var i, Baza, NovaBaza: integer; S: string; P: Polje; 
begin {Pretvarjanje}
  for i := 1 to 100 do Test;
  Write('tevilo: '); ReadLn(S);
  Write('Pretvori iz osnove: '); ReadLn(Baza);
  Write('V osnovo: '); ReadLn(NovaBaza);
  i := Length(S); P := S;
  Pretvori(P, Baza, NovaBaza, i);
  WriteLn('Rezultat: ', Copy(P, 1, i));
end. {Pretvarjanje}

