program IskanjeVzorcev; { RTK 1989.3.1 }
const MaxDolz = 100; 
type 
  Vzorci = array[1..20] of record 
    Zlog: array[1..MaxDolz] of byte; 
    Dolzina: integer; 
  end; {Vzorci}
  Datoteka = file of byte; 

procedure Isci(var F: Datoteka; V: Vzorci; N: integer); 
var 
  Okno: array[1..MaxDolz] of byte;  
  Polozaj, Konec, i, j, Prebrano: integer; 
begin
  Prebrano := 0; Konec := 0; 
  while not Eof(F) do begin 
    { Preberimo naslednji zlog datoteke F.  Tabelo Okno
      uporabljamo, kot da bi bila krona: za zadnjim
      elementom pride spet prvi. }
    Konec := Konec + 1; if Konec > MaxDolz then Konec := 1; 
    Read(F, Okno[Konec]);  
    if Prebrano < MaxDolz then Prebrano := Prebrano + 1; 
    for i := 1 to N do with V[i] do if Prebrano >= Dolzina then begin 
      { S tevcem j se bomo sprehajali po vsebini vzorca V[i],
        s tevcem Poloaj pa po zadnji V[i].Dolzina zlogih iz datoteke. }
      Polozaj := Konec - Dolzina + 1; j := 1; 
      if Polozaj <= 0 then Polozaj := Polozaj + MaxDolz; 
      while j <= Dolzina do begin 
        if Okno[Polozaj] <> Zlog[j] then break; 
        j := j + 1; Polozaj := Polozaj + 1; if Polozaj > MaxDolz then Polozaj := 1; 
      end; {while}
      if j > Dolzina then { Vse se ujema! }
        WriteLn('zaporedje ', i, ' odmik ', FilePos(F) - Dolzina); 
    end; {if, with, for} 
  end; {while} 
end; {Isci} 

{-----------------------------------------------------------------------------}
{ Testiranje.                                                                 }
{-----------------------------------------------------------------------------}

procedure Postavi(var V: Vzorci; i: integer; S: string);
var j: integer;
begin
  with V[i] do begin
    Dolzina := Length(S);
    for j := 1 to Dolzina do Zlog[j] := Ord(S[j]);
  end; {with}
end; {Postavi}

var V: Vzorci; F: Datoteka;
begin {IskanjeVzorcev}
  Postavi(V, 1, 'Aera');
  Postavi(V, 2, 'legion');
  Postavi(V, 3, 'tralala');
  Postavi(V, 4, 'Arabia');
  Postavi(V, 5, 'Roman');
  Postavi(V, 6, 'wild');
  { V tej datoteki je prvi razdelek prvega poglavja Gibbonove
    Zgodovine zatona in propada Rimskega cesarstva. }
  Assign(F, 'rtk89s3n1.in'); 
  Reset(F);
  Isci(F, V, 6);
  Close(F);
end. {IskanjeVzorcev}