program VelikiKalkulator; { RTK 1989.3.4 }

function Eval(var f: text): real; 

  const EOL = Chr(13); 
  var PutBack: char; 

  function GetCh: char; 
  begin
    if PutBack = Chr(0) then begin 
      if Eoln(f) then begin PutBack := EOL; ReadLn(f) end
      else Read(f, PutBack); 
    end; {if}
    GetCh := PutBack; PutBack := Chr(0);  
  end; {GetCh} 

  const EolT = 'e'; Num = 'n'; 
  type TokenT = record t: char; x: real end;
  
  procedure NextToken(var t: TokenT); 
  var c: char; u: real; 
  begin
    { Preskoimo presledke. } 
    repeat c := GetCh until not (c in [' ', Chr(9)]); 
    if c = EOL then { Prili smo do konca izraza. } 
      begin t.t := EolT; PutBack := c end
    else if c in ['+', '-', '/', '*', '(', ')'] then 
      t.t := c { Operator ali oklepaj, ki je e sam zase osnovni simbol. } 
    else if c in ['0'..'9', '.'] then begin
      { Prebrati moramo tevilo. } 
      t.t := Num; t.x := 0;  
      while c in ['0'..'9'] do { tevke pred decimalno piko. } 
        begin t.x := t.x * 10 + (Ord(c) - Ord('0')); c := GetCh end;
      if c = '.' then begin
        c := GetCh; u := 1; { Decimalna pika in mogoe e tevke za njo. } 
        while c in ['0'..'9'] do begin 
          u := u * 0.1; t.x := t.x + u * (Ord(c) - Ord('0')); c := GetCh; 
        end; {while}
      end; {if}
      PutBack := c; { Ta znak e ne spada ve k naemu tevilu. } 
    end else 
      begin WriteLn('Nedovoljen znak: #', Ord(c)); t.t := EolT end;
  end; {NextToken} 

  function EvalExpr(var t: TokenT): real; forward; 

  function EvalAtom(var t: TokenT): real; 
  begin
    if t.t = '(' then begin
      NextToken(t); EvalAtom := EvalExpr(t); 
      if t.t <> ')' then WriteLn('Priakoval bi zaklepaj, ne pa ', t.t, '.'); 
      NextToken(t); 
    end else if t.t = Num then begin
      EvalAtom := t.x; NextToken(t); 
    end else if t.t = '-' then begin
      NextToken(t); EvalAtom := -EvalAtom(t);  
    end else WriteLn('Priakoval bi oklepaj, unarni minus ', 
                     'ali tevilko, ne pa ', t.t, '.'); 
  end; {EvalAtom} 
  
  function EvalTerm(var t: TokenT): real; 
  var x, y: real; op: char; 
  begin
    x := EvalAtom(t); 
    while t.t in ['*', '/'] do begin 
      op := t.t; NextToken(t); y := EvalAtom(t); 
      if op = '*' then x := x * y else x := x / y; 
    end; {while}
    if not (t.t in ['+', '-', ')', EolT]) then 
      WriteLn('Priakoval bi zaklepaj, + , - ali konec izraza, ne pa ', t.t, '.'); 
    EvalTerm := x; 
  end; {EvalTerm} 

  function EvalExpr(var t: TokenT): real; 
  var x, y: real; op: char; 
  begin
    x := EvalTerm(t); 
    while t.t in ['+', '-'] do begin 
      op := t.t; NextToken(t); y := EvalTerm(t); 
      if op = '+' then x := x + y else x := x - y; 
    end; {while}
    if not (t.t in [')', EolT]) then 
      WriteLn('Priakoval bi zaklepaj ali konec izraza, ne pa ', t.t, '.'); 
    EvalExpr := x; 
  end; {EvalTerm} 

var t: TokenT; x: real; 
begin {Eval} 
  PutBack := Chr(0); NextToken(t); 
  if t.t = EolT then begin WriteLn('Datoteka je prazna!'); Eval := 0 end
  else begin 
    x := EvalExpr(t); Eval := x; 
    if t.t <> EolT then WriteLn('Izraz ni pravilne oblike! ', 
                                'Zatakne se pri ', t.t, '.'); 
    WriteLn('Vrednost izraza: ', x:10:5); 
  end; {if}
end; {Eval} 

var T: text;
begin {VelikiKalkulator}
  if ParamCount > 0 then begin
    Assign(T, ParamStr(1)); Reset(T);
    while not Eof(T) do Eval(T);
    Close(T);
  end else begin 
    WriteLn('Vnesi izraz: ');
    Eval(Input);
  end; {if}
end. {VelikiKalkulator}
