program Hollerith; { RTK 1990.1.2 }

const 
  LetoMin = 1880; { prvo mono leto rojstva } 
  LetoMax = 1990; { zadnje mono leto rojstva } 
  MaxN = 13000;   { maksimalno tevilo oseb } 
type 
  OsebaT = record 
    Ime: packed array[1..100] of char; { podatki o osebi } 
    Leto: LetoMin..LetoMax; 
  end; {OsebaT} 
  TabelaT = array[1..MaxN] of OsebaT; 

{ Dejansko tevilo oseb, katerih podatke dobimo v tabeli a, je n. 
  Urejene podatke o osebah vrnemo v tabeli b. }
procedure Uredi(var a, b: TabelaT; n: integer); 
var 
  { so[y] je tevilo oseb, rojenih v letu y } 
  so: array[LetoMin..LetoMax] of integer;
  i, j, k: integer; { tevci } 
begin
  { V tabeli so pretejemo, koliko oseb se je rodilo v posameznem letu. } 
  for i := LetoMin to LetoMax do so[i] := 0; { zaetne vrednosti } 
  for i := 1 to n do so[a[i].Leto] := so[a[i].Leto] + 1; { tetje } 
  { Podatke v tabeli preraunamo tako, da nam povedo, kje v pravilno 
    urejeni tabeli b se zano osebe z danim letom rojstva. }
  j := so[LetoMin]; so[LetoMin] := 1; 
  for i := LetoMin + 1 to LetoMax do 
    begin k := so[i]; so[i] := so[i - 1] + j; j := k; end;
  { Podatke o osebah prepiemo iz tabele a v tabelo b; 
    upotevamo, da nam so[r] pove, na katero mesto v tabeli b 
    pride naslednja oseba z letom rojstva r. }
  for i := 1 to n do begin 
    b[so[a[i].Leto]] := a[i]; 
    so[a[i].Leto] := so[a[i].Leto] + 1;
  end; {for}
end; {Uredi} 

var a, b: TabelaT; n, i, c: integer; S: string;
begin {Hollerith}

  { Preberimo podatke s standardnega vhoda.  Za vsako osebo
    naj bo ena vrstica, v njej pa leto rojstva, presledek in ime. }
  n := 0;
  while not Eof do begin
    ReadLn(S);
    i := 1; while i <= Length(S) do 
      if S[i] = ' ' then break else i := i + 1;
    Assert(n < MaxN);
    n := n + 1;
    Val(Copy(S, 1, i - 1), a[n].Leto, c);
    while i <= Length(S) do 
      if S[i] = ' ' then i := i + 1 else break;
    a[n].Ime := Copy(S, i, Length(S) - i + 1);
  end; {while}

  Uredi(a, b, n);
  
  for i := 1 to n do WriteLn(b[i].Leto, ' ', b[i].Ime);
end. {Hollerith}
