program Domine(Output); { RTK 1990.3.1 }
const 
  n = 10;  { tevilo domin, ki jih elimo postaviti v vrsto } 
  m = 5;   { najveje tevilo pik na polju domine } 
type 
  DominaT = array[0..1] of 1..m;  { domina ima dve polji } 
  PostavitevT = record            { domina v vrsti } 
    Dom: integer;   { tevilka domine } 
    Obrat: integer;   { obrat domine (0 ali 1) } 
  end; {PostavitevT} 
var 
  Vrsta: array[0..n] of PostavitevT;  { vrsta, ki jo sestavljamo } 
  Zaloga: array[1..n] of DominaT;     { domine, ki jih imamo na razpolago } 
  Zasedene: set of 1..n;              { domine, ki so e v vrsti } 

{ Prebere, izrauna, napravi ali naara zalogo domin; na primer takole: } 
procedure NapraviDomine; 
var i: integer; 
begin
  for i := 1 to n do begin 
    Zaloga[i, 0] := Random(m) + 1; Zaloga[i, 1] := Random(m) + 1; 
    WriteLn(i:3, ' (', Zaloga[i, 0]:1, ', ', Zaloga[i, 1]:1, ')'); 
  end; {for}
end; {NapraviDomine} 

procedure IzpisiDomine; 
var i: integer; 
begin
  for i := 1 to n do with Vrsta[i] do 
    WriteLn(Dom:3, ' (', Zaloga[Dom, Obrat mod 2]:1, ', ', 
                         Zaloga[Dom, (Obrat + 1) mod 2]:1, ')'); 
end; {IzpisiDomine} 

{ Vrne tevilo pik domine na polju Poz, upotevajo rotacijo domine. } 
function StPik(v: PostavitevT; Poz: integer): integer; 
begin
  StPik := Zaloga[v.Dom, (v.Obrat + Poz) mod 2]; 
end; {StPik} 

{ Primerja dve domini. } 
function Primerjaj(v1, v2: PostavitevT): boolean; 
begin
  if Zasedene = [] then Primerjaj := true { prve domine ne primerjamo s prejnjo } 
  else Primerjaj := StPik(v1, 1) = StPik(v2, 0); 
end; {Primerjaj} 

{ Postavi domine od mesto naprej. } 
function Postavi(Mesto: integer): boolean; 
var 
  Nova: PostavitevT;        { domina, ki jo bomo postavili na Mesto } 
  Uspeh, Neuspeh: boolean;  { uspeh/neuspeh postavitve vrste od Mesto naprej } 
begin
  with Nova do begin Dom := 0; Obrat := 0 end; { zanemo s prvo domino } 
  Uspeh := false; Neuspeh := false; 
  repeat 
    Nova.Dom := Nova.Dom + 1; 
    if Nova.Dom > n then    { ni lo ---poskusimo z obrnjenimi dominami } 
      with Nova do begin Dom := 1; Obrat := Obrat + 1; end;
    if Nova.Obrat > 1 then 
      Neuspeh := true       { izrpali smo vse monosti -- ne gre } 
    else if not (Nova.Dom in Zasedene) 
            and Primerjaj(Vrsta[Mesto - 1], Nova) then begin 
      Vrsta[Mesto] := Nova; Zasedene := Zasedene + [Nova.Dom]; 
      if Mesto = n then Uspeh := true else Uspeh := Postavi(Mesto + 1); 
      if not Uspeh then Zasedene := Zasedene - [Nova.Dom]; 
    end; {if}
  until Uspeh or Neuspeh; 
  Postavi := Uspeh; 
end; {Postavi} 

begin {Domine} 
  Randomize;
  NapraviDomine; Zasedene := []; 
  if not Postavi(1) then WriteLn('Domin se ne da postaviti v vrsto.') 
  else begin WriteLn('Domine se da postaviti v vrsto:'); IzpisiDomine end; 
end. {Domine} 
