program PrepoznavanjeZnakov; { RTK 1991.2.3 }
type ZnakT = array[1..7] of boolean; 
const OblikeZnakov: array['0'..'9'] of ZnakT = (
  (True, True, True, False, True, True, True),
  (False, False, True, False, False, True, False),
  (True, False, True, True, True, False, True),
  (True, False, True, True, False, True, True),
  (False, True, True, True, False, True, False),
  (True, True, False, True, False, True, True),
  (True, True, False, True, True, True, True),
  (True, False, True, False, False, True, False),
  (True, True, True, True, True, True, True),
  (True, True, True, True, False, True, True) );

{ Vrne najbolj podoben znak podani obliki
  ali pa presledek, e najde ve enakovrednih kandidatov. }
function DolociZnak(zn: ZnakT): char;
var
  c, NajblizjiZnak: char; 
  Razl, MinRazl: integer; 

  { Funkcija vrne tevilo segmentov, v katerih se razlikujeta dva znaka. }
  function Razlika(var zn1, zn2: ZnakT): integer; 
  var i, Razl: integer; 
  begin {Razlika} 
    Razl := 0; 
    for i := 1 to 7 do 
      if zn1[i] <> zn2[i] then Razl := Razl + 1; 
    Razlika := Razl; 
  end; {Razlika} 

begin {DolociZnak} 
  NajblizjiZnak := ' '; MinRazl := 8; 
  for c := '0' to '9' do begin 
    Razl := Razlika(zn, OblikeZnakov[c]); 
    if Razl < MinRazl then 
      begin MinRazl := Razl; NajblizjiZnak := c; end
    else if Razl = MinRazl then 
      NajblizjiZnak := ' '; { Ne moremo enolino doloiti znaka. } 
  end; {for}
  DolociZnak := NajblizjiZnak; 
end; {DolociZnak}

procedure NarisiZnak(var zn: ZnakT);
begin
  Write(' '); if zn[1] then Write('-') else Write(' '); WriteLn;
  if zn[2] then Write('|') else Write(' '); 
  Write(' '); if zn[3] then Write('|') else Write(' '); WriteLn;
  Write(' '); if zn[4] then Write('-') else Write(' '); WriteLn;
  if zn[5] then Write('|') else Write(' '); 
  Write(' '); if zn[6] then Write('|') else Write(' '); WriteLn;
  Write(' '); if zn[7] then Write('-') else Write(' '); WriteLn;
end; {NarisiZnak}

procedure Test(s1, s2, s3, s4, s5, s6, s7: boolean);
var zn: ZnakT; c: char;
begin
  zn[1] := s1; zn[2] := s2; zn[3] := s3; zn[4] := s4;
  zn[5] := s5; zn[6] := s6; zn[7] := s7;
  NarisiZnak(zn);
  c := DolociZnak(zn);
  if c = ' ' then WriteLn('Dvoumen znak.')
  else WriteLn('Prepoznan kot: ', c);
end; {Test}

var c: char;
begin {PrepoznavanjeZnakov}
  {for c := '0' to '9' do begin WriteLn(c); NarisiZnak(OblikeZnakov[c]) end;}
  Test(False, False, True, True, False, True, False);
  Test(False, False, True, True, False, True, True);
  Test(False, False, True, False, False, True, False);
  Test(False, False, False, False, False, False, False);
  Test(False, False, True, True, True, True, True);
  Test(False, False, True, True, True, False, False);
end. {PrepoznavanjeZnakov}
