program Oklepaji; { RTK 1991.3.2 }

const 
  MxPri = 1200; 
type 
  SymDef = (sClen, sOp, sKonec); 
  PtExpDef = ^ExpDef; 
  ExpDef = record 
    case Sym: SymDef of 
      sClen: (Val: char); 
      sOp: (Op: char; LExp, RExp: PtExpDef); 
  end; {ExpDef}
var 
  Sym: SymDef; 
  Ch: char; 
  OpPri: integer; 

  procedure Error(n: integer); forward; 
  procedure GetSym; forward; 

procedure Term(MxOpPri: integer; var Root: PtExpDef); 
var 
  MnOpPri: integer; 
  OldRoot: PtExpDef; 
begin {Term} 
  if Sym <> sClen then Error(2); { Predpostavimo, da je trenutni simbol len. } 
  New(Root); Root^.Sym := Sym; Root^.Val := Ch; 
  MnOpPri := 0; GetSym; 
  while (Sym = sOp) and (OpPri <= MxOpPri) and (OpPri >= MnOpPri) do begin 
    OldRoot := Root; New(Root); Root^.Sym := Sym; 
    Root^.Op := Ch; Root^.LExp := OldRoot; MnOpPri := OpPri; 
    GetSym; Term(MnOpPri, Root^.RExp); 
  end; {while}
end; {Term} 

procedure WrtTerm(Root: PtExpDef); 
begin
  if Root^.Sym = sClen then Write(Root^.Val) 
  else begin 
    Write('('); WrtTerm(Root^.LExp); Write(Root^.Op); 
    WrtTerm(Root^.RExp); Write(')'); 
  end; {if}
end; {WrtTerm} 

procedure DelTerm(Root: PtExpDef);
begin
  if Root = nil then exit;
  if Root^.Sym = sOp then begin
    DelTerm(Root^.LExp); DelTerm(Root^.RExp);
  end; {if}
  Dispose(Root);
end; {DelTerm}

procedure Parse; 
var Root: PtExpDef; 
begin
  GetSym; Term(MxPri, Root); 
  if Sym <> sKonec then Error(3); 
  WrtTerm(Root); 
  DelTerm(Root);
end; {Parse} 

{-----------------------------------------------------------------------------}
{ Sledi implementacija zgoraj obljubljenega podprograma GetSym in e glavni   }
{ del programa, ki prevekuje izraze, podane v ukazni vrstici, ali pa         }
{ od uporabnika prebere izraz s standardnega vhoda.                           }
{-----------------------------------------------------------------------------}

var Izraz: string; 
    Polozaj: integer;
    
procedure Error(n: integer);
begin
  WriteLn('Napaka t. ', n, ', izraz = "', Izraz, '", poloaj = ', Polozaj);
  Halt(n);
end; {Error}

procedure GetSym; 
var c: char; L: integer;
begin
  L := Length(Izraz);
  while Polozaj <= L do begin
    c := Izraz[Polozaj]; Polozaj := Polozaj + 1;
    if c in ['A'..'Z', 'a'..'z'] then begin
      Sym := sClen; Ch := c; OpPri := -1; exit;
    end else if c in ['+', '-', '*', '^'] then begin
      Sym := sOp; Ch := c; 
      if c = '^' then OpPri := 1
      else if c = '*' then OpPri := 2
      else OpPri := 3;
      exit;
    end else if not (c in [' ', #9]) then
      Error(1);
  end; {while}
  Sym := sKonec; Ch := #0; OpPri := -1;
end; {GetSym}

procedure ObdelajIzraz(S: string);
begin
  Izraz := S;
  Polozaj := 1;
  WriteLn('Prvotni izraz:       ', Izraz);
  Write('Z dodanimi oklepaji: '); 
  Parse; WriteLn;
end; {ObdelajIzraz}

var i: integer;
begin {Oklepaji}
  { Pa e primeri iz besedila naloge. }
  ObdelajIzraz('a + b');
  ObdelajIzraz('a + b * c');
  ObdelajIzraz('a * b + c');
  ObdelajIzraz('a + b ^ c * d');
  ObdelajIzraz('a + b + c');
  if ParamCount > 0 then begin
    for i := 1 to ParamCount do ObdelajIzraz(ParamStr(1));
  end else begin
    WriteLn('Vnesi izraz, sestavljen iz operatorjev +, -, *, ^ in ');
    WriteLn('spremenljivk A, ..., Z, a, ..., z: ');
    ReadLn(Izraz); ObdelajIzraz(Izraz);
  end; {if}
end. {Oklepaji}
