program Barvanje; { RTK 1994.2.4 }

{ S simboli MAJHEN, VELIK in MERITEV lahko izbiramo,
  koliken zaslon bo program barval in ali bo to
  tudi zares prikazoval na zaslonu. }

{$IFDEF MAJHEN}
{$DEFINE CRT}
{$ENDIF}

{$IFDEF VELIK}
{$DEFINE GRAPH}
{$ENDIF}

{ S simbolomoma GRAPH in CRT lahko zahtevamo prikaz barvanja 
  zaslona (v tekstovnem ali pa v grafinem nainu), program
  pa na koncu tudi poaka, da pritisnemo kakno tipko.  
  e ni definiran nobeden od njiju, program ne bo prikazoval
  barvanja (kar je koristno npr. pri merjenju asa). }

{$IFDEF GRAPH}
uses Graph, Crt;
{$ENDIF}
{$IFDEF CRT}
uses Crt;
{$ENDIF}

{$IFDEF MAJHEN}
const XMax = 80; YMax = 50;
{$ENDIF}
{$IFDEF VELIK}
const XMax = 1280; YMax = 1024;
{$ENDIF}
{$IFDEF MERITEV} 
const XMax = 1280; YMax = 1024;
{$ENDIF}

  procedure Pobarvaj(x, y: integer); forward;
  function Pobarvana(x, y: integer): boolean; forward;
  
procedure PobarvajZaslon1; 
var i, r, x, y, Stevec: integer; 
    Vrstica: array[0..YMax - 1] of integer; 
begin
  for i := 0 to YMax - 1 do Vrstica[i] := XMax; 
  Stevec := 0;
  for i := XMax * YMax downto 1 do begin 
    r := Random(i); y := 0; 
    while r >= Vrstica[y] do 
      begin r := r - Vrstica[y]; y := y + 1; end; 
    x := 0; Vrstica[y] := Vrstica[y] - 1; 
    Stevec := Stevec + r;
    while r >= 0 do begin 
      if not Pobarvana(x, y) then r := r - 1; 
      x := x + 1; 
    end; {while}
    Pobarvaj(x - 1, y);
  end; {for}
  WriteLn('tevilo klicev podprograma Pobarvana: ', Stevec);
end; {PobarvajZaslon1} 

procedure PobarvajZaslon2; 
var i, x, y, Stevec: integer; 
begin
  Stevec := 0;
  for i := 1 to XMax * YMax do begin 
    repeat
      x := Random(XMax); y := Random(YMax);
      Stevec := Stevec + 1;
    until not Pobarvana(x, y);
    Pobarvaj(x, y);
  end; {for}
  WriteLn('tevilo klicev podprograma Pobarvana: ', Stevec);
  WriteLn('Priakovana vrednost: ', 
    (XMax * YMax * (Ln(XMax * YMax) + 0.5772156649 + 1.0 / (2 * XMax * YMax))):0:3);
end; {PobarvajZaslon2} 

procedure PobarvajZaslon3; 
const StOstalih = XMax;
var i, r, x, y, Stevec: integer; 
    Ostale: array[1..StOstalih] of integer;
begin
  Stevec := 0;
  for i := 1 to XMax * YMax - StOstalih do begin 
    repeat
      x := Random(XMax); y := Random(YMax);
      Stevec := Stevec + 1;
    until not Pobarvana(x, y);
    Pobarvaj(x, y);
  end; {for}
  { Ostalo je e StOstalih nepobarvanih tok. 
    Poglejmo, katere so to. }
  i := 0; for y := 0 to YMax - 1 do for x := 0 to XMax - 1 do
    if not Pobarvana(x, y) then 
      begin i := i + 1; Ostale[i] := y * XMax + x; end;
  Stevec := Stevec + XMax * YMax;
  { Pobarvajmo te preostale toke v nakljunem vrstnem redu. }
  for i := StOstalih downto 1 do begin
    r := Random(i) + 1;
    Pobarvaj(Ostale[r] mod XMax, Ostale[r] div XMax);
    Ostale[r] := Ostale[i];
  end; {for}
  WriteLn('tevilo klicev podprograma Pobarvana: ', Stevec);
  WriteLn('Priakovana vrednost: ', 
    (XMax * YMax * (1 + Ln(XMax * YMax / StOstalih))):0:3);
end; {PobarvajZaslon3} 

procedure PobarvajZaslon4;
var i, x, y: integer; r, a, m: int64;
begin
  { m := najmanja potenca tevila 2, ki je >= XMax * YMax. }
  m := 1; while m < XMax * YMax do m := m * 2;
  { Zdi se, da je pri vejem m barvanje zaslona videti bolj
    nakljuno.  Brez spodnjega stavka ima program na zaetku
    barvanja nekatere stolpce precej raji kot nekatere druge. }
  m := m * 4;
  { a := oblike 8k + 5, niti preblizu 1 niti preblizu m. }
  a := ((m div 2) div 8) * 8 + 5;
  { Naeloma je vseeno, s katerim r zanemo, saj bo imelo 
    nae zaporedje periodo m. }
  r := Random(XMax * YMax);
  i := 0;
  while i < XMax * YMax do begin
    if r < XMax * YMax then begin
      x := r mod XMax; y := r div XMax;
      Assert(not Pobarvana(x, y));
      Pobarvaj(x, y); i := i + 1;
    end; {if}
    r := (a * r + 1) mod m;
  end; {while}
end; {PobarvajZaslon4}

procedure PobarvajZaslon5;
const StZamikov = 2;
var ZamikX: array[1..StZamikov, 0..XMax - 1] of integer;
    ZamikY: array[1..StZamikov, 0..YMax - 1] of integer;
    x, y, xx, yy, i: integer;
begin
  for i := 1 to StZamikov do begin
    { V vsaki od tabel ZamikX[i] in ZamikY[i] pripravimo 
      nek primeren nakljuno izbran zamik. }
    for x := 0 to XMax - 1 do ZamikX[i, x] := Random(YMax);
    for y := 0 to YMax - 1 do ZamikY[i, y] := Random(XMax);
  end; {for i}
  for x := 0 to XMax - 1 do for y := 0 to YMax - 1 do begin
    xx := x; yy := y;
    for i := 1 to StZamikov do begin
      { Ciklino zamaknemo stolpec xx za ZamikX[i, xx] vrstic navzdol. }
      yy := yy + ZamikX[i, xx]; if yy >= YMax then yy := yy - YMax;
      { Ciklino zamaknemo vrstico yy za ZamikY[i, yy] stolpcev v desno. }
      xx := xx + ZamikY[i, yy]; if xx >= XMax then xx := xx - XMax;
    end; {for i}
    Assert(not Pobarvana(xx, yy));
    Pobarvaj(xx, yy);
  end; {for x, y}
end; {PobarvajZaslon5}

procedure PobarvajZaslon6;
var x, y: integer;
begin
  for y := 0 to YMax - 1 do for x := 0 to XMax - 1 do
    Pobarvaj(x, y);
end; {PobarvajZaslon6}

procedure PobarvajZaslon7;
var VrstniRed: array[0..XMax * YMax - 1] of integer;
    i, j, x, y: integer;
begin
  for i := 0 to XMax * YMax - 1 do begin
    j := Random(i + 1);
    VrstniRed[i] := VrstniRed[j];
    VrstniRed[j] := i;
  end; {for}
  for i := 0 to XMax * YMax - 1 do begin
    x := VrstniRed[i] mod XMax; y := VrstniRed[i] div XMax;
    Assert(not Pobarvana(x, y));
    Pobarvaj(x, y);
  end; {for i}
end; {PobarvajZaslon6}

var 
  a: array[0..YMax - 1, 0..(XMax - 1) div 8] of byte;
  StPobarvanih: longint;

procedure Pobarvaj(x, y: integer);
var b, m: byte;
begin
  b := a[y, x div 8]; 
  m := 1 shl (x mod 8);
  Assert((b and m) = 0);
  a[y, x div 8] := b or m;
  StPobarvanih := StPobarvanih + 1;
{$IFDEF GRAPH}  
  PutPixel(x, y, White);
{$ENDIF}  
{$IFDEF CRT}
  GotoXY(x + 1, y + 1); Write(x mod 10); Delay(10);
{$ENDIF}
end; {Pobarvaj}

function Pobarvana(x, y: integer): boolean;
begin
  {if (x < 0) or (x >= XMax) or (y < 0) or (y >= YMax) then 
    begin WriteLn(x, ' ', y); Assert(false); end;}
  Pobarvana := (a[y, x div 8] and (1 shl (x mod 8))) <> 0;
end; {Pobarvana}

var y, x, Alg, i: integer;
{$IFDEF GRAPH}
var GDrv, GMode: word;
{$ENDIF}
begin {Barvanje}

  if ParamCount > 0 then begin
    Val(ParamStr(1), Alg, i); if i > 0 then Alg := 1; 
    WriteLn('Algoritem: ', Alg);
  end else begin
    WriteLn('Moni algoritmi:                         Zahtevnost:   asovna,   prostorska');
    WriteLn('0 sploh ne barvamo                                     O(1)             O(1)');
    WriteLn('1 hranimo t. nepobarvanih za vsako vrstico            O(X Y (X + Y))   O(Y)');
    WriteLn('2 izberi nakljuno toko; e je nepobarvana, jo pobarvaj; ');
    WriteLn('  ponavljaj, dokler niso vse pobarvane                 O(X Y ln(XY))    O(1)');
    WriteLn('3 kot (2), dokler ne ostane X nepobarvanih;');
    WriteLn('  tiste daj v tabelo, premeaj, pobarvaj               O(X Y ln Y)      O(X)');
    WriteLn('4 pobarvaj toko r (e r < XY), nato ');
    WriteLn('  postavi r := (a * r + 1) mod b in ponavljaj          O(XY)            O(1)');
    WriteLn('5 izmenino nakljuno zamikaj vrstice in stolpce       O(XY)            O(1)');
    WriteLn('6 od zgoraj navzdol (ne nakljuno)                     O(XY)            O(1)');
    WriteLn('7 naivna reitev                                       O(XY)            O(XY)');
    Write('Izberi algoritem: '); ReadLn(Alg);
  end; {if}
{$IFDEF GRAPH}  
  GDrv := Detect; InitGraph(GDrv, GMode, 'c:\bp\bgi'); 
  if GraphResult <> grOk then Halt(1); 
{$ENDIF}
{$IFDEF CRT}
  ClrScr;
{$ENDIF}

  for y := 0 to YMax - 1 do for x := 0 to (XMax - 1) div 8 do
    a[y, x] := 0;
  StPobarvanih := 0;
  
  if Alg > 0 then begin
    if Alg = 1 then PobarvajZaslon1
    else if Alg = 2 then PobarvajZaslon2
    else if Alg = 3 then PobarvajZaslon3
    else if Alg = 4 then PobarvajZaslon4
    else if Alg = 5 then PobarvajZaslon5
    else if Alg = 6 then PobarvajZaslon6
    else if Alg = 7 then PobarvajZaslon7;
    Assert(StPobarvanih = XMax * YMax);
  end; {if}
  
{$IFDEF GRAPH}
  ReadKey;
  CloseGraph;
{$ENDIF}
{$IFDEF CRT}
  ReadKey;
  ClrScr;
{$ENDIF}
end. {Barvanje}
