program IzrazVDrevo; { RTK 1994.3.4 }
uses Graph; 

const MaksDolzinaNiza = 25; { najveja dolina niza } 
type NizT = array[1..MaksDolzinaNiza] of char; 
var {\tabset}Izraz: NizT; 
  Z: integer; 
  X, LeviX, DesniX : real; 

procedure OdpriGraficniNacin; 
var GDrv, GMode: integer; 
begin
  GDrv := Detect; 
  InitGraph(GDrv, GMode, 'c:\bp\bgi'); 
  if GraphResult <> grOk then Halt(1); 
end; {OdpriGraficniNacin} 

procedure ZapriGraficniNacin; 
begin
  CloseGraph; 
end; {ZapriGraficniNacin} 

procedure Crta(X1, Y1, X2, Y2: real); 
begin
  Line(Round(X1 * 50), Round(Y1 * 50), 
       Round(X2 * 50), Round(Y2 * 50)); 
end; {Crta} 

procedure RisiDrevo(Globina: integer; var LeviX, DesniX: real); 
var 
  LeviPodX, DesniPodX: real; 
  Prvic: boolean; 
begin
  Prvic := true; 
  repeat 
    if Izraz[Z] = '[' then begin
      Z := Z + 1; RisiDrevo(Globina + 1, LeviPodX, DesniPodX); 
      Crta(LeviPodX, Globina, DesniPodX, Globina); 
      DesniX := LeviPodX + (DesniPodX - LeviPodX) / 2; 
      if Prvic then begin LeviX := DesniX; Prvic := false; end;
      Crta(DesniX, Globina, DesniX, Globina - 1); 
    end
    else if Izraz[Z] = '*' then begin 
      Z := Z + 1; 
      Crta(X, Globina, X, Globina - 1); 
      DesniX := X; 
      if Prvic then begin LeviX := DesniX; Prvic := false; end;
      X := X + 1; 
    end; {if}
  until (Izraz[Z] = ']') or (Izraz[Z] = ' '); 
  Z := Z + 1; 
end; {RisiDrevo} 
  
procedure Demo(Niz: NizT); 
begin
  ClearViewPort; Izraz := Niz; Z := 1; X := 1; 
  RisiDrevo(1, LeviX, DesniX); ReadLn; 
end; {Demo} 

begin {IzrazVDrevo}
  OdpriGraficniNacin; 
  Demo('[[***]*[**]]             '); 
  Demo('[[***]*[*[[**]*][**]]]   '); 
  Demo('[[***]*[*[[**]*]]]       '); 
  Demo('[[[[*]]][**[*]*]]        '); 
  ZapriGraficniNacin; 
end. {IzrazVDrevo}
