program Enigma(Output); { RTK 1995.3.1 }
type z = packed array[1..255] of char; 
var 
  p, a, r: z; 
  j: integer; 

function Length(s: z):integer; 
var i: integer; 
begin
  i := 255; while (i > 1) and (s[i] in [#0, ' ']) do i := i - 1; 
  if (i = 1) and (s[1] = ' ') then Length := 0 else Length := i; 
end;

{ Zamenja a[j..j + LP - 1] z nizom r. }
procedure Replace(LP, LR, LA: integer; var a, r: z); 
var k: integer; 
begin
  if LP < LR then begin 
    {for k := 255 downto j + LP do a[k] := a[k - (LR - LP)];}
    for k := LA + LR downto j + LR do a[k] := a[k - (LR - LP)]; 
    for k := 1 to LR do a[k + j - 1] := r[k]; 
  end else begin 
    for k := j to LA - (LP - LR) do a[k] := a[k + (LP - LR)]; 
    for k := 1 to LR do a[k + j - 1] := r[k]; 
  end;
end;

{ Poie prvo pojavitev p-ja znotraj a[j+1..LA] in jo zamenja z r.
  Vrne indeks, na katerem se je najdena pojavitev zaela.
  e take pojavitve ni, vrne 0.  Vrnjeno vrednost tudi shrani v j. }
function RKSearch(var a, p, r: z):integer; 
const 
  q = 33554393; { pratevilo } 
  d = 32; 
var 
  h1, h2, dM, i, LP, LA, LR: integer; 
begin
  LP := Length(p); LA := Length(a); LR := Length(r); 
  dM := 1; for i := 1 to LP - 1 do dM := (d * dM) mod q; 
  h1 := 0; for i := 1 to LP do h1 := (h1 * d + ord(p[i])) mod q; 
  h2 := 0; for i := 1 to LP do h2 := (h2 * d + ord(a[i + j])) mod q; 
  i := j + 1; 
  while (h1 <> h2) and (i <= LA - LP) do begin 
    { Invarianta: h2 je indeks podniza a[i..i + LP - 1]. }
    h2 := (h2 + d * q - ord(a[i]) * dM) mod q; 
    h2 := (h2 * d + ord(a[i + LP])) mod q; 
    i := i + 1; 
  end; 
  if h1 = h2 then begin 
    { Podniz a[i..i + LP - 1] je enak nizu p -- ali pa imamo smolo
      in sta indeksa enaka, eprav sta niza razlina.  To se sicer
      v praksi ne dogaja prav pogosto, je pa isto mogoe. }
    RKSearch := i; j := i; Replace(LP, LR, LA, a, r); 
  end else begin 
    RKSearch := 0; j := 0; 
  end;
end;

begin
  r := 'baba '; p := 'ba '; a := 'alibaba in tirideset barbarov.              '; 
  j := 0; 
  while RKSearch(a, p, r) <> 0 do begin 
    writeln(a:Length(a)); writeln('^':j); 
    {j := j + Length(r) - Length(p);}
    j := j + Length(r) - 1;
  end;
end. 