program PokvarjeniZaslon; { RTK 1995.3.2 }
type 
  Stevka = 0..9;
  Segment = 1..7;
  Segmenti = set of Segment;
const 
  OpisiStevk: array[Stevka] of Segmenti = (
    [1, 2, 3, 5, 6, 7], [3, 6], [1, 3, 4, 5, 7], [1, 3, 4, 6, 7], 
    [2, 3, 4, 6], [1, 2, 4, 6, 7], [1, 2, 4, 5, 6, 7], 
    [1, 3, 6], [1, 2, 3, 4, 5, 6, 7], [1, 2, 3, 4, 6, 7] );
  SegmentovPriStevki: array[Stevka] of integer = (6, 2, 5, 5, 4, 5, 6, 3, 7, 6);
  MaxN = 10;
type ZaslonT = array[1..MaxN] of Segmenti;

procedure PoisciVrednosti(var Zaslon: ZaslonT; N: integer);
var 
  StMoznih, Trenutna, Najboljsa: array[1..MaxN] of integer;
  Mozne: array[1..MaxN, 1..10] of Stevka;
  MinStSegmentov, StSegmentov: integer;
  
  procedure Rekurzija(Mesto: integer);
  var i, j, Vsota, StaroStSegmentov: integer;
  begin
    StaroStSegmentov := StSegmentov; 
    for j := 1 to StMoznih[Mesto] do begin 
      { Postavimo naslednjo mono tevko na indeks Mesto. }
      Trenutna[Mesto] := Mozne[Mesto, j];
      StSegmentov := StaroStSegmentov + SegmentovPriStevki[Trenutna[Mesto]];
      if StSegmentov >= MinStSegmentov then 
        continue; { Brezupno -- segmentov je e zdaj preve. }
      { e e nismo na zadnjem mestu, nadaljujmo z rekurzijo. }
      if Mesto < N then begin Rekurzija(Mesto + 1); continue end;
      { Kombinacija je sestavljena do konca -- preverimo, e je vsota tevk deljiva z 10. }
      Vsota := 0;
      for i := 1 to N do Vsota := Vsota + Trenutna[i];
      if Vsota mod 10 <> 0 then continue;
      { To je torej nova najbolja znana kombinacija -- zapomnimo si jo. }
      MinStSegmentov := StSegmentov;
      for i := 1 to N do Najboljsa[i] := Trenutna[i]; 
    end; {for}
    StSegmentov := StaroStSegmentov; 
  end; {Rekurzija}
  
var i: integer; s: Stevka;
begin {PoisciVrednosti}

  { Za vsako mesto na zaslonu poglejmo, katere tevke bi utegnile
    povzroiti tako stanje segmentov, kot ga vidimo tam na zaslonu. }
  for i := 1 to N do begin
    StMoznih[i] := 0;
    for s := 0 to 9 do if Zaslon[i] - OpisiStevk[s] = [] then
      begin StMoznih[i] := StMoznih[i] + 1; Mozne[i, StMoznih[i]] := s end;
    if StMoznih[i] = 0 then exit; { Do takega stanja sploh ne more priti! }
  end; {for i}
  Write('StMoznih:'); for i := 1 to N do Write(' ', StMoznih[i]); WriteLn;
  
  MinStSegmentov := 7 * N + 1; StSegmentov := 0;
  Rekurzija(1);
  
  if MinStSegmentov > 7 * N then WriteLn('Ni reitev!')
  else begin
    Write('Najbolja reitev:');
    for i := 1 to N do Write(' ', Najboljsa[i]);
    WriteLn;
  end; {if}
end; {PoisciVrednosti}

const 
  Primer1: ZaslonT = ([1, 3, 4, 6, 7], [1, 3], [], [], [], [], [], [], [], []);
  Primer2: ZaslonT = ([1, 3, 4, 6, 7], [1, 3], [2, 4], [1, 7], [1, 2], [4], [6, 7], [1, 7], [1, 2, 3, 4], []);
begin {PokvarjeniZaslon}
  PoisciVrednosti(Primer1, 2);
  PoisciVrednosti(Primer2, 9);
end. {PokvarjeniZaslon}
