program Isci; { RTK 1995.Z }
{ e poenemo ta program brez parametrov, bo pripravil
  indeksno datoteko (na trenutnem direktoriju pa mora
  biti prisotna besede.txt), drugae pa bo izpisal
  vse besede, blinje besedi ParamStr(1) (na trenutnem
  direktoriju mora biti prisotna indeksna datoteka). }

{----------------------------------------------------------------------------} 
{ Skupne deklaracije                                                         } 
{----------------------------------------------------------------------------} 

const 
  MaxDolz = 12; 
  StCrk = 29; 
  Crke: string= 'ABCDEFGHIJKLMNOPQRSTUVWXYZ^[@'; 
  ImeIndeksa = 'index.dat'; 
type 
  Beseda = string[MaxDolz]; 
  Glava = array[1..MaxDolz, 1..MaxDolz, 1..StCrk] of integer; 
  SeznamCrk = array[1..MaxDolz] of 1..StCrk; 

{ Vrne tevilo razlinih rk v besedi W.  V sc vrne seznam teh rk. } 
function RazlicneCrke(const W: Beseda; var sc: SeznamCrk): integer; 
var i, j, M: integer; 
begin
  M := 0; 
  for i := 1 to Length(W) do begin 
    j := 1; while (j < i) and (W[j] <> W[i]) do Inc(j); 
    if j = i then begin Inc(M); sc[M] := Pos(W[i], Crke); end;
  end; {for}
  RazlicneCrke := M; 
end; {RazlicneCrke} 

{----------------------------------------------------------------------------} 
{ Priprava indeksa                                                           } 
{----------------------------------------------------------------------------} 

type 
  TextBuf = array[0..4095] of byte; 
  BufText = record { za hitreje delo s tekstovnimi datotekami } 
    T: text; Buf: ^TextBuf; 
  end;

procedure Odpri(var ob: BufText; const ImeDat: string; Novo: boolean); 
begin
  Assign(ob.T, ImeDat); New(ob.Buf); 
  SetTextBuf(ob.T, ob.Buf^); 
  if Novo then Rewrite(ob.T) else Reset(ob.T); 
end; {Odpri} 

procedure Zapri(var ob: BufText); 
begin 
  Close(ob.T); 
  Dispose(ob.Buf); 
end; {Zapri}

function ToStr(N: integer): string; 
var S: string; 
begin 
  Str(N, S); 
  ToStr := S;
end;

{ Za vsak (n, m) pripravi po eno datoteko z vsemi besedami iz W(n, m). 
  (Torej z vsemi besedami doline n, ki vsebujejo natanko
  m razlinih rk.) }
procedure RazdeliWnm; 
var T: BufText; W: Beseda; N, M: integer; sc: SeznamCrk; 
    Tnm: array[1..MaxDolz] of BufText; 
begin
  for N := 1 to MaxDolz do begin 
    for M := 1 to N do 
      Odpri(Tnm[M], 'Wnm' + ToStr(N) + '-' + ToStr(M) + '.txt', true); 
    Odpri(T, 'besede.txt', false); 
    while not Eof(T.T) do begin 
      ReadLn(T.T, W); 
      if Length(W) = N then 
        WriteLn(Tnm[RazlicneCrke(W, sc)].T, W); 
    end; {while}
    Zapri(T); for M := 1 to N do Zapri(Tnm[M]); 
  end; {for N} 
end; {RazdeliWnm} 

{ Pripravi po eno datoteko za vsak (n, a); v njej so besede iz W(n, m, a) 
  (torej besede iz W(n, m), ki vsebujejo rko a) za vse m, urejene po 
  naraajoih m.  V G[n, m, a] vpie tevilo besed v mnoici W(n, m, a).  
  Datoteke s seznami W(n, m) na koncu pobrie. }
procedure PripraviWna(N: integer; var G: Glava); 
var M, A: integer; T, Ta: BufText; W: Beseda; 
begin
  for M := 1 to N do begin 
    for A := 1 to StCrk do begin 
      G[N, M, A] := 0; 
      Odpri(Ta, 'Wna' + ToStr(N) + '-' + ToStr(A) + '.txt', M = 1); 
      if M > 1 then Append(Ta.T); 
      Odpri(T, 'Wnm' + ToStr(N) + '-' + ToStr(M) + '.txt', false); 
      while not Eof(T.T) do begin 
        ReadLn(T.T, W); 
        if Pos(Crke[A], W) > 0 then 
          begin WriteLn(Ta.T, W); Inc(G[N, M, A]); end; 
      end; {while}
      Zapri(T); Zapri(Ta); 
    end; {for A} 
    Erase(T.T); 
  end; {for M} 
end; {PripraviWna} 

{ Doda vsebino vseh W(n, m, a) v indeksno datoteko.  Vsaka od teh skupin je
  skompresirana posebej.  V G[N, M, A] vpie tevilo 5-bitnih znakov v 
  skompresiranem zapisu seznama W(n, m, a).  Pomone datoteke na koncu pobrie. }
procedure DodajWna(var F: file; N, A: integer; var G: Glava); 
const BufLen = 8192; 
var Buf: array[0..BufLen - 1] of byte; BufPos, Bit, D: integer; 

  procedure Zapisi; { Zapie vsebino bloka Buf na disk. } 
  begin
    if (Bit > 0) and (BufPos < BufLen) then Inc(BufPos);  
    BlockWrite(F, Buf, BufPos); BufPos := 0; 
  end; {Zapisi} 

  procedure Dodaj5Bitov(X: integer); 
  begin
    Buf[BufPos] := (Buf[BufPos] or (X shl Bit)) and $ff; Inc(Bit, 5); Inc(D); 
    if Bit >= 8 then begin{ Nekaj bitov zapiimo v naslednji byte. } 
      Dec(Bit, 8); Inc(BufPos); 
      if BufPos = BufLen then Zapisi; 
      Buf[BufPos] := X shr (5 - Bit); 
    end; {if}
  end; {Dodaj5Bitov} 

var M, i, j: integer; T: BufText; W, Wp: Beseda; 
begin {DodajWna} 
  Odpri(T, 'Wna' + ToStr(N) + '-' + ToStr(A) + '.txt', false); 
  for M := 1 to N do begin
    BufPos := 0; Bit := 0; D := 0; Buf[BufPos] := 0; W := ''; 
    for i := 1 to G[N, M, A] do begin 
      Wp := W; ReadLn(T.T, W); 
      j := 1; if i > 1 then while (j < N) and (Wp[j] = W[j]) do Inc(j); 
      Dodaj5Bitov(j - 1); { Skupni zaetek s prejnjo besedo. } 
      { Shrani e preostanek besede. } 
      while j <= N do begin Dodaj5Bitov(Pos(W[j], Crke)); Inc(j); end;
    end; {for i} 
    Zapisi; G[N, M, A] := D; 
  end; {for M} 
  Zapri(T); Erase(T.T); 
end; {DodajWna} 

{ Na podlagi datoteke besede.txt pripravi indeksno datoteko, 
  ki jo bomo uporabljali pri odgovarjanju na poizvedbe. }
procedure PripraviIndeks; 
var N, A: integer; G: Glava; F: file; 
begin
  RazdeliWnm; 
  for N := 1 to MaxDolz do PripraviWna(N, G); 
  Assign(F, ImeIndeksa); Rewrite(F, 1); 
  BlockWrite(F, G, SizeOf(G)); 
  for N := 1 to MaxDolz do for A := 1 to StCrk do DodajWna(F, N, A, G); 
  Seek(F, 0); BlockWrite(F, G, SizeOf(G)); 
  Close(F); 
end; {PripraviIndeks} 

{----------------------------------------------------------------------------} 
{ Odgovarjanje na poizvedbe                                                  } 
{----------------------------------------------------------------------------} 

type 
  Pojavitve = array[1..StCrk] of integer; 
  Buffer = array[0..31807] of byte; 
  Odmiki = array[1..MaxDolz, 1..MaxDolz, 1..StCrk] of longint; 

{ Koliko bytov potrebujemo za zapis N 5-bitnih simbolov? } 
function PakDolz(N: longint): integer; 
  begin PakDolz := (N * 5 + 7) div 8; end;

{ Za vsako trojico (n, m, a) izrauna, na katerem odmiku v  
  datoteki se zacnejo podatki za W(n, m, a). }
procedure IzracunajOdmike(const G: Glava; var O: Odmiki); 
var N, M, A: integer; OO: longint; 
begin
  OO := SizeOf(G); 
  for N := 1 to MaxDolz do for A := 1 to StCrk do for M := 1 to N do 
    begin O[N, M, A] := OO; Inc(OO, PakDolz(G[N, M, A])); end;
end; {IzracunajOdmike} 

procedure PoisciBliznje(const P: Beseda); 
var Buf: ^Buffer; BufPos, Bit: integer; { Blok z besedami v kompresirani obliki. } 
    Znakov: integer; { tevilo e neprebranih 5-bitnih znakov v bloku Buf. } 
    
  { Vrne naslednjih 5 bitov iz bloka Buf.  Povea Bit in BufPos, zmanja Znakov. } 
  function Beri5Bitov: integer; 
  var X: integer; 
  begin
    X := (Buf^[BufPos] shr Bit) and 31; Inc(Bit, 5); 
    if Bit >= 8 then begin { Nekaj bitov vzemimo e iz naslednjega byta. } 
      Dec(Bit, 8); Inc(BufPos); 
      X := (X or (Buf^[BufPos] shl (5 - Bit))) and 31; 
    end; {if}
    Beri5Bitov := X; Dec(Znakov); 
  end; {Beri5Bitov} 

var 
  F: file; G: ^Glava; O: ^Odmiki; 
  M: integer; PojP: Pojavitve; CrkeP: SeznamCrk; { Lastnosti vzorca P. } 
  
  { Pregleda besede iz mnoice W(NN, MM, A), ki se morajo nahajati 
    v bloku Buf od indeksa BufPos naprej.  e je LeCePrva = true, 
    se vsaka beseda izpie le, e ne vsebuje nobene rke, manje od A. 
    To se uporablja, e je vzorec prazen niz in hoemo v resnici  
    izpisati vse besede iz W(NN, MM), vsako natanko enkrat. }
  procedure PreglejWnma(NN, MM, A: integer; LeCePrva: boolean); 
  var i: integer; PojW: Pojavitve; Bliznja: boolean; CrkeW: SeznamCrk; W: Beseda; 
  begin
    Znakov := G^[NN, MM, A]; Bit := 0; 
    while Znakov > 0 do begin
    
      i := Beri5Bitov + 1; { Skupni zaetek s prejnjo besedo. } 
      Bliznja := true; 
      while i <= NN do begin { Preberimo preostanek besede. } 
        CrkeW[i] := Beri5Bitov; 
        if LeCePrva and (CrkeW[i] < A) then Bliznja := false; 
        Inc(i); 
      end; {while}
      if not Bliznja then continue; { Vsebuje rko, manjo od A. } 
      
       { Preverimo, e je res blinja. } 
      for i := 1 to M do PojW[CrkeP[i]] := PojP[CrkeP[i]]; 
      for i := 1 to NN do Dec(PojW[CrkeW[i]]); 
      i := 1; while (i <= M) and Bliznja do 
        if (PojW[CrkeP[i]] < -2) or (PojW[CrkeP[i]] > 0) 
        then Bliznja := false else Inc(i); 
        if Bliznja then begin { e je blinja, jo izpiimo. } 
        W[0] := Chr(NN); 
        for i := 1 to NN do W[i] := Crke[CrkeW[i]]; 
        WriteLn(W); 
      end; {if Bliznja} 
      
    end; {while}
    if Bit > 0 then Inc(BufPos); 
  end; {PreglejWnma} 

var N, NN, A, i, j, KA: integer; D, KD: longint; 
begin
  Assign(F, ImeIndeksa); Reset(F, 1); New(G); New(O); 
  BlockRead(F, G^, SizeOf(G^)); IzracunajOdmike(G^, O^); 
  N := Length(P); M := RazlicneCrke(P, CrkeP); New(Buf); 
  
  if N = 0 then begin { Prazen vzorec obravnavajmo posebej. } 
    { Izpisati bomo morali vse besede doline 1 in 2. } 
    D := 0; for A := 1 to StCrk do Inc(D, PakDolz(G^[1, 1, A]) +  
      PakDolz(G^[2, 1, A]) + PakDolz(G^[2, 2, A])); 
    Seek(F, O^[1, 1, 1]); BlockRead(F, Buf^, D); BufPos := 0; 
    for j := 1 to 2 do for A := 1 to StCrk do for i := 1 to j do 
      PreglejWnma(j, i, A, True); 
    exit; 
  end; {if prazen vzorec} 
  
  for A := 1 to StCrk do PojP[A] := 0; 
  for i := 1 to N do Inc(PojP[Pos(P[i], Crke)]); 
  for j := 0 to 2 do if N + j <= MaxDolz then begin
    NN := N + J; 
    
    { Zdaj se bomo ukvarjali z besedami iz W(NN, MM) za NN = N + j, 
      M <= MM <= M + j.  Naj bo A tista rka, pri kateri bomo morali 
      prebrati najmanj podatkov. }
    for i := 1 to M do begin
      KA := CrkeP[i]; KD := PakDolz(G^[NN, M, KA]); 
      if j > 0 then Inc(KD, PakDolz(G^[NN, M + 1, KA])); 
      if j > 1 then Inc(KD, PakDolz(G^[NN, M + 2, KA])); 
      if (i = 1) or (KD < D) then begin A := KA; D := KD; end;
    end; {for i} 
    if D <= 0 then continue; 
    
    Seek(F, O^[NN, M, A]); BlockRead(F, Buf^, D); BufPos := 0; 
    for i := 0 to j do PreglejWnma(NN, M + i, A, false); 
    
  end; {for, if} 
  Dispose(Buf); Close(F); Dispose(G); Dispose(O); 
end; {PoisciBliznje} 

begin {Isci} 
  if ParamCount < 1 then 
    PripraviIndeks 
  else if Length(ParamStr(1)) <= MaxDolz then 
    PoisciBliznje(ParamStr(1)); 
end. {Isci} 
