program VnasanjeKljuca; { RTK 1996.1.4 }
uses Crt, Windows;
const 
  MinMed = 50;       { Minimalni sprejemljivi as med dvema pritiskoma 
                       (drugae drugi pritisk ignoriramo). }
  Natancnost = 20;   { Koliko niha as med dvema zaporednima "pritiskoma", 
             e uporabnik v resnici tii tisto tipko ves as pritisnjeno. }
  Dolzina = 128;     { Dolina kljua v bitih. } 
type 
  KljucT = array[0..(Dolzina + 7) div 8 - 1] of byte; 

{ Videti je, da FreePascal nima funkcije, ki bi
  vraala as v tisoinkah sekunde.  Lahko bi
  uporabili GetTime (iz modula Dos), ki vraa as 
  do stotinke natanno.  Raje pa bomo uporabili
  QueryPerformanceCounter iz modula Windows, ki naj bi bil 
  vraa precej bolj natanen as (obiajno do
  priblino milijoninke sekunde natanno). }
var Stevec0, Frekvenca: LARGE_INTEGER;
 
function Timer: integer;
var Stevec: LARGE_INTEGER;
begin
  QueryPerformanceCounter(@Stevec);
  Timer := (1000 * (Stevec.QuadPart - Stevec0.QuadPart)) div Frekvenca.QuadPart;
end; {Timer}

{ Podprogram za branje kljua. }
procedure PripraviKljuc(var Kljuc: KljucT); 
var Bit, Cas, PrejCas, Med, PrejMed: integer; 
    Tipka, PrejTipka: char; 
begin
  WriteLn('Tipkajte...'); 
  Bit := 0; PrejTipka := ReadKey; PrejCas := Timer; PrejMed := 0; 
  while Bit < Dolzina do begin 
    Tipka := ReadKey; Cas := Timer; Med := Cas - PrejCas; 
    Write('Tipka: ', Ord(Tipka):3, ' (prej ', Ord(PrejTipka):3, 
          '); Med: ', Med:4, ' (prej ', PrejMed:4, 
          '); Bit: ', Bit:3, '.              ', #13, #10);
    if (Med > MinMed) and ((Tipka <> PrejTipka) or 
                           (Abs(Med - PrejMed) > Natancnost)) then begin 
      if (Bit mod 8) = 0 then Kljuc[Bit div 8] := 0; 
      Kljuc[Bit div 8] := Kljuc[Bit div 8] or ((Med and 1) shl (Bit mod 8)); 
      PrejMed := Med; PrejTipka := Tipka; Bit := Bit + 1; 
    end; {if}; 
    PrejCas := Cas; 
  end; {while}
  WriteLn; WriteLn('Klju uspeno prebran.'); 
end; {PripraviKljuc} 

const Hex = '0123456789abcdef';
var Kljuc: KljucT; i: integer;
begin
  { Inicializacija za funkcijo Timer. }
  QueryPerformanceCounter(@Stevec0);
  QueryPerformanceFrequency(@Frekvenca);
  { Preberimo klju. }
  PripraviKljuc(Kljuc);
  { Izpiimo klju. }
  for i := 0 to (Dolzina + 7) div 8 - 1 do 
    Write(Hex[1 + Kljuc[i] mod 16], Hex[1 + Kljuc[i] div 16]);
  WriteLn;
end. {VnasanjeKljuca}
