program Vdori; { RTK 1996.2.4 }
uses Crt;

{-- Vmesnik, ki ga vidita tekmovaleva podprograma. --------------------------}

const TTL = 180;
type Naslov = array[1..2] of integer;

function Cas: integer; forward;
procedure Dodaj(N: Naslov; t: integer); forward;
procedure Brisi(N: Naslov); forward;
procedure Obnovi(N: Naslov; t: integer); forward;
function Poisci(N: Naslov): integer; forward;
function Naslednji(var N: Naslov; var t: integer): boolean; forward;

{-- Tekmovaleva podprograma. ------------------------------------------------}

procedure Vsiljivec(N: Naslov); 
var M: Naslov; t, tM: integer; Nasel: boolean; 
begin
  t := Cas; 
  { Preverimo, e e obstaja omejitev za N-jevo podmreo. } 
  { - Slabost naslednje razliice je, da bo obnovila omejitev
      za celo podmreo, tudi e je e stara in bi jo bilo
      v resnici treba zbrisati (in nato uvesti omejitev le 
      za naslov N). }
  (*
  M[1] := N[1]; M[2] := 0; 
  if Poisci(M) > 0 then begin Obnovi(M, t); exit; end;
  *)
  { - Morali bi poizvedeti, kako stara je omejitev na podmreo 
      (e sploh obstaja).  Vmesnik, ki ga imamo na voljo,
      tega ne omogoa drugae kot s podprogramom Naslednji. }
  M[1] := N[1] - 1; M[2] := 9999;
  if Naslednji(M, tM) then if (M[1] = N[1]) and (M[2] = 0) then begin
    if t - tM < TTL then Obnovi(M, t)
    else begin Brisi(M); Dodaj(N, t); end;
    exit;
  end; {if}
  M[1] := N[1]; M[2] := 0;
  { Preverimo, e obstaja omejitev za kak drug naslov iz te podmree. } 
  Nasel := false; 
  while Naslednji(M, tM) and not Nasel do begin 
    if M[1] <> N[1] then break; 
    if (M[2] <> N[2]) then 
      if (t - tM < TTL) then Nasel := true
                        else Brisi(M); 
  end; {while}
  if Nasel then begin 
    { Nadomestimo omejitve za naslove te podmree z omejitvijo za celo podmreo. } 
    M[1] := N[1]; M[2] := 0;  
    while Naslednji(M, tM) do 
      if M[1] <> N[1] then break else Brisi(M); 
    M[1] := N[1]; M[2] := 0; Dodaj(M, t); 
  end else if Poisci(N) > 0 then Obnovi(N, t) 
  else Dodaj(N, t); 
end; {Vsiljivec}

procedure Sprosti; 
var N: Naslov; t, tN: integer; 
begin
  N[1] := 0; N[2] := 0; t := Cas; 
  while Naslednji(N, tN) do 
    if t - tN > TTL then Brisi(N); 
end; {Sprosti} 

{-----------------------------------------------------------------------------}

type 
  Zapis = record
    N: Naslov;
    t: integer;
  end; {Zapis}
 
const MaxZapisov = 10000; 
var 
  T: integer;
  Tabela: array[1..MaxZapisov] of Zapis;
  StZapisov: integer;

function Cas: integer;
  begin Cas := T; end;

procedure Dodaj(N: Naslov; t: integer); 
begin
  Assert(Poisci(N) = 0);
  Inc(StZapisov);
  Tabela[StZapisov].N := N;
  Tabela[StZapisov].t := t;
end; {Dodaj}

procedure Brisi(N: Naslov); 
var i: integer;
begin
  i := Poisci(N); Assert(i > 0);
  Tabela[i] := Tabela[StZapisov];
  Dec(StZapisov);
end; {Brisi}

procedure Obnovi(N: Naslov; t: integer);
var i: integer;
begin
  i := Poisci(N); Assert(i > 0);
  Tabela[i].t := t;
end; {Obnovi}

function Poisci(N: Naslov): integer;
var i: integer;
begin
  for i := 1 to StZapisov do 
    if (Tabela[i].N[1] = N[1]) and (Tabela[i].N[2] = N[2]) then
      begin Poisci := i; exit; end;
  Poisci := 0;
end; {Poisci}

{ Poie najmanji naslov, veji od N, in ga vrne v (N, t).
  e takega ni, vrne false. }
function Naslednji(var N: Naslov; var t: integer): boolean;
var Nasel: boolean; NN: Naslov; i, tn: integer;
begin
  Nasel := false;
  for i := 1 to StZapisov do
    if (Tabela[i].N[1] > N[1]) or ((Tabela[i].N[1] = N[1]) and (Tabela[i].N[2] > N[2])) then
    if (not Nasel) or (Tabela[i].N[1] < NN[1]) or ((Tabela[i].N[1] = NN[1]) and (Tabela[i].N[2] < NN[2])) then
      begin Nasel := true; NN := Tabela[i].N; tn := Tabela[i].t; end;
  Naslednji := Nasel;
  if Nasel then begin N := NN; t := tn; end;
end; {Naslednji}

procedure IzpisiTabelo;
var i: integer;
begin
  Write('[T = ', T:4, ']  Tabela (naslov, starost):');
  for i := 1 to StZapisov do 
    Write(' ', Tabela[i].N[1], '.', Tabela[i].N[2], '/', T - Tabela[i].t);
  WriteLn;
end; {IzpisiTabelo}

var c: char; N: Naslov;
begin {Vdori}
  StZapisov := 0; T := 0;
  WriteLn('Simulator vdiranja v omreja');
  WriteLn('Pritisni V za vdor, S za klic podprograma Sprosti, ');
  WriteLn('T za prikaz tabele, P za pavzo, Q za izhod.');
  while true do begin
  
    Write('[T = ', T:4, ']', #13);
    
    if KeyPressed then begin
      c := UpCase(ReadKey);
      if c = #0 then c := ReadKey;
      
      case c of
      'V': begin
        { Izmislimo si naslov, s katerega so poskuali vdreti.  Nekateri 
          naslovi in podomreja se pojavljajo pogosteje kot nekateri drugi. }
        if Random(10) < 7 then N[1] := 1 + Random(3)
        else N[1] := 4 + Random(6);
        if Random(10) < 7 then N[2] := N[1] + Random(3)
        else N[2] := 1 + Random(10);
        
        IzpisiTabelo;
        WriteLn('[T = ', T:4, ']  Vdor z naslova (', N[1], '.', N[2], ')!');
        Vsiljivec(N);
        IzpisiTabelo;
      end;
      
      'S': begin
        IzpisiTabelo;
        WriteLn('[T = ', T:4, ']  Podprogram Sprosti pobrie stare zapise.');
        Sprosti;
        IzpisiTabelo;
      end;
  
      'P': begin
        Write('(pavza)', #13);
        repeat until KeyPressed; 
        continue;
      end;
      
      'T': IzpisiTabelo;
      'X', 'Q': exit;
      
      end; {case}
      
    end; {if KeyPressed}
    
    Inc(T); Delay(100);
  end; {while}
end. {Vdori}
