program ObleganiISP; { RTK 1997.1.4 }
uses Crt;

  { Vmesnik, ki ga vidi podprogram KlicanObZasedbi. }
  const N = 10; { tevilo modemov }
  function Zaseden(i: integer): integer; forward;
  procedure Sprosti(i: integer); forward;

{ To je podprogram, ki so ga morali napisati tekmovalci. }
procedure KlicanObZasedbi; 
var VsiZasedeni: boolean; i, T, KateriNajdlje, KolikoNajdlje: integer; 
begin
  VsiZasedeni := true; i := 1; 
  while VsiZasedeni and (i <= N) do begin 
    T := Zaseden(i); 
    if T = 0 then 
      VsiZasedeni := false
    else if (i = 1) or (T > KolikoNajdlje) then 
      begin KateriNajdlje := i; KolikoNajdlje := T; end; 
    i := i + 1;
  end; {while}
  if VsiZasedeni then Sprosti(KateriNajdlje); 
end; {KlicanObZasedbi} 

{-----------------------------------------------------------------------------}
{ Preostanek programa simulira dogajanje pri ponudniku dostopa do interneta.  }
{-----------------------------------------------------------------------------}

{ Predpostavimo, da se prihajanje zahtekov na strenik
  obnaa kot Poissonov proces:
    P(n zahtevkov v asu t) = e^(-lambda t) (lambda t)^n / n!
  Pri tem je lambda priakovano tevilo zahtevkov v eni sekundi.
  Naj bo T as med dvema zaporednima zahtevkoma.
    P(T < t) = P(vsaj en zahtevek v asu t)
             = 1 - P(0 zahtevkov v asu t) = 1 - e^(-lambda t).
  Taki porazdelitvi pravimo "eksponentna porazdelitev".
  e je verjetnost P(T < t) enaka p (0 <= p < 1), je
    t = - ln(1 - p) / lambda. 
  Isto porazdelitev bomo uporabili tudi za as strebe
  (kako dolgo se uporabnik zadri na streniku, e ga seveda
  strenik prej ne vre z linije). 
    V teoriji strebe bi rekli, da imamo streni sistem tipa M/M/1.
  Glej npr.
    http://www.eventhelix.com/RealtimeMantra/CongestionControl/m_m_1_queue.htm
    http://mathworld.wolfram.com/ExponentialDistribution.html 
    L. Kleinrock: Queueing Systems }
function RandExp(Lambda: real): real;
  begin RandExp := -Ln(1.0 - Random) / Lambda; end;

{ Kot RandExp, le da vraa pozitivna cela tevila. }
function RandExpI(Lambda: real): integer;
var t: integer;
begin 
  t := Round(RandExp(Lambda)); 
  if t < 1 then t := 1; 
  RandExpI := t; 
end; {RandExpI}

const 
  { Na podlagi spodnje konstante si program nakljuno 
    izbira, kako dolgo po klicu prejnjega uporabnika
    bo poklical naslednji uporabnik. }
  SekundMedDvemaKlicema = 10;    { 10 sekund }
  { Spodnja konstanta doloa, kako dolgo bi uporabniki v
    povpreju sami ostali na zvezi, tudi e jih ne bi
    mi metali dol.  Na podlagi te konstante se ob vsakem
    klicu zgenerira nakljuno trajanje seje in tisti
    uporabnik se po toliko asa sam odklopi, e ga mi
    ne odklopimo e prej. }
  PricakovanoTrajanjeSeje = 600; { 10 minut }
var
  Cas: integer;
  ZasedenOd, ZasedenDo: array[1..N] of integer; { -1, e je prost }
  PotrebenWriteLn: boolean;

function CasMedKlicema: integer;
  begin CasMedKlicema := RandExpI(1.0 / SekundMedDvemaKlicema); end;
function TrajanjeSeje: integer;
  begin TrajanjeSeje := RandExpI(1.0 / PricakovanoTrajanjeSeje); end;

procedure WriteLnCeJePotreben;
begin
  if PotrebenWriteLn then WriteLn;
  PotrebenWriteLn := false;
end; {WriteLnCeJePotreben}

function Zaseden(i: integer): integer; 
begin 
  if ZasedenOd[i] < 0 then Zaseden := 0
  else Zaseden := Cas - ZasedenOd[i];
end;
  
procedure Sprosti(i: integer); 
begin 
  if ZasedenOd[i] < 0 then exit;
  WriteLnCeJePotreben; WriteLn('[T = ', Cas:4, ']  Prekinemo zvezo ', i, 
    ' (povezan ', Cas - ZasedenOd[i], ' s, bi bil e ', ZasedenDo[i] - Cas, ' s).');
  ZasedenOd[i] := -1; ZasedenDo[i] := -1;
end; {Sprosti}

procedure PrikaziStanje;
var i: integer;
begin
  Write('[T = ', Cas:4, ']');
  for i := 1 to N do 
    if ZasedenOd[i] >= 0 then 
      Write('  ', (Cas - ZasedenOd[i]):4, '/', (ZasedenDo[i] - Cas):4)
    else Write('  ----/----');
  Write(#13); PotrebenWriteLn := true;
end; {PrikaziStanje}

var 
  NaslednjiKlic, i: integer; c: char;
begin {ObleganiISP}
  WriteLn('Simulator podnudnika dostopa do interneta');
  WriteLn('Pritisni Q ali X za izhod, poljubno drugo tipko za pavzo.');
  WriteLn('Za vsak modem pove prvo tevilo, kako dolgo e traja');
  WriteLn('trenutni klic na njem, drugi pa, kako dolgo e bo.');
  Cas := 0; PotrebenWriteLn := false;
  for i := 1 to N do ZasedenOd[i] := -1;
  NaslednjiKlic := Cas + CasMedKlicema;
  while true do begin

    PrikaziStanje;
  
    { Mogoe se bo kdo sam od sebe odklopil. }
    for i := 1 to N do if (ZasedenOd[i] >= 0) and (Cas >= ZasedenDo[i]) then begin
      ZasedenOd[i] := -1; 
      WriteLnCeJePotreben; WriteLn('[T = ', Cas:4, ']  Uporabnik modema ', i, ' je sam prekinil zvezo.');
    end; {if, for}
  
    { Simulirajmo klice uporabnikov. }
    while Cas >= NaslednjiKlic do begin
      KlicanObZasedbi;
      WriteLnCeJePotreben;
      { Poglejmo, e obstaja prost modem. }
      i := 1; while i <= N do if ZasedenOd[i] < 0 then break else i := i + 1;
      { e ga ni, zavrnemo klic. }
      if i > N then WriteLn('[T = ', Cas:4, ']  Zavrnemo zvezo klicatelju.')
      { Sicer postavimo novega uporabnika na prvi prosti modem. }
      else begin
        ZasedenOd[i] := Cas; ZasedenDo[i] := Cas + TrajanjeSeje; 
        WriteLn('[T = ', Cas:4, ']  Sprejmemo klic, ki bo trajal ', 
          ZasedenDo[i] - ZasedenOd[i], ' s, do T = ', ZasedenDo[i], '.');
      end; {if}
      NaslednjiKlic := Cas + CasMedKlicema;
    end; {while}
    
    Inc(Cas); Delay(100);
    if KeyPressed then begin
      c := UpCase(ReadKey); if c = #0 then c := UpCase(ReadKey);
      if (c = 'Q') or (c = 'X') then break;
      WriteLnCeJePotreben; Write('(pavza)', #13); 
      c := UpCase(ReadKey); if c = #0 then c := UpCase(ReadKey);
      if (c = 'Q') or (c = 'X') then break;
      PrikaziStanje;
    end; {if}
        
  end; {while}
  WriteLn;
end. {ObleganiISP}
