program Ravbarji; { RTK 1997.3.2 }
{ Vhodna datoteka naj vsebuje v vsaki vrstici dve
  tevilki meanov, ki sta prijatelja.  Dovolj je,
  e je vsak par omenjen le enkrat (ne najprej kot
  i j in nato e kot j i).  e je najvija omenjena
  tevilka v datoteki N, bo program reeval problem z
  N meani.  e kaken ni omenjen, je pa brez 
  prijateljev in bo obdral pomembnost 1. }

const MaxN = 100; 

{-----------------------------------------------------------------------------}
{ Implementacija podprogramov PreberiMescane, Tekoci in Naslednji, za katere  }
{ je v nalogi pisalo, naj tekmovalec predpostavi, kot da e obstajajo.        }
{ Do globalnih spremenljivk, ki jih ti podprogrami uporabljajo, naj glavni    }
{ del programa ne bi dostopal neposredno.                                     }
{-----------------------------------------------------------------------------}

type PrijateljiT = set of 1..100;
var 
  TrenMescan, TrenPrijatelj, StMescanov: Integer;
  Prijatelji: array[1..100] of PrijateljiT;

function PreberiMescane: Integer; 
var T: text; i, j: Integer; 
begin 
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'rtk97s3n2.in');
  Reset(T);
  for i := 1 to 100 do Prijatelji[i] := [];
  StMescanov := 0;
  while not Eof(T) do begin
    ReadLn(T, i, j);
    if i > StMescanov then StMescanov := i;
    if j > StMescanov then StMescanov := j;
    Prijatelji[i] := Prijatelji[i] + [j];
    Prijatelji[j] := Prijatelji[j] + [i];
  end; {while}
  Close(T);
  TrenMescan := -1; TrenPrijatelj := StMescanov + 1;
  PreberiMescane := StMescanov;
end; {PreberiMescane}

procedure Tekoci(i: Integer); 
  begin TrenMescan := i; TrenPrijatelj := 1; end;

function Naslednji: Integer;
begin
  while TrenPrijatelj <= StMescanov do
    if TrenPrijatelj in Prijatelji[TrenMescan] then 
      begin Naslednji := TrenPrijatelj; Inc(TrenPrijatelj); Exit; end
    else Inc(TrenPrijatelj);
  Naslednji := 0;
end; {Naslednji}
  
{-----------------------------------------------------------------------------}
{ Glavni del programa                                                         }
{-----------------------------------------------------------------------------}

var n, i, u, v, StMocnejsih: integer; 
  StZMocjo, NaslZMocjo: array[0..MaxN - 1] of integer; 
  Moc, PoMoci, Mocnejsi: array[1..MaxN] of integer; 
  Pomembnost: array[1..MaxN] of real; Delez: real;
begin
  n := PreberiMescane; 
  { Doloimo mo vsakega meana. } 
  for u := 1 to n do begin 
    Moc[u] := 0; Tekoci(u); 
    while Naslednji <> 0 do Inc(Moc[u]); 
  end; {for}
  { Koliko jih ima doloeno mo? } 
  for i := 0 to n - 1 do StZMocjo[i] := 0; 
  for u := 1 to n do Inc(StZMocjo[Moc[u]]); 
  { V tabeli PoMoci bomo pripravili tevilke meanov po 
    naraajoi moi.  NaslZMocjo[i] pove, kam je treba 
    vpisati naslednjega meana z mojo i.}
  NaslZMocjo[0] := 1; 
  for i := 1 to n - 1 do NaslZMocjo[i] := NaslZMocjo[i - 1] + StZMocjo[i - 1]; 
  for u := 1 to n do begin 
    PoMoci[NaslZMocjo[Moc[u]]] := u; 
    Inc(NaslZMocjo[Moc[u]]); 
  end; {for}
  { Prenaajmo pomembnosti od ibkejih k monejim. } 
  for u := 1 to n do Pomembnost[u] := 1.0; 
  for i := 1 to n do begin 
    u := PoMoci[i];  
    { Poglejmo, kateri u-jevi prijatelji so moneji od njega. } 
    Tekoci(u); StMocnejsih := 0; v := Naslednji; 
    while v <> 0 do begin 
      if Moc[v] > Moc[u] then 
        begin Inc(StMocnejsih); Mocnejsi[StMocnejsih] := v; end; 
      v := Naslednji; 
    end; {while}
    if StMocnejsih > 0 then begin
      { Razdelimo u-jevo pomembnost med moneje prijatelje. } 
      Delez := Pomembnost[u] / StMocnejsih;  
      Pomembnost[u] := 0; 
      while StMocnejsih > 0 do begin 
        v := Mocnejsi[StMocnejsih]; Dec(StMocnejsih);
        Pomembnost[v] := Pomembnost[v] + Delez;
      end; {while}
    end; {if}
  end; {for}
  { Izpiimo meane z nenielno pomembnostjo. } 
  for u := 1 to n do if Pomembnost[u] > 0 then 
    WriteLn(u, ' ', Pomembnost[u]:0:5); 
end. {Ravbarji}
