program Rozine1; { RTK 1997.Z.2 }
{ Naivna reitev: za vsako toko (X0, Y0) pregleda vse
  ostale toke, da ugotovi, katere so iz obmoja
  N = [X0, X0 + A] x [Y0 - B, Y0 + B].
  Nato poskusi postaviti spodnjo stranico pravokotnika na 
  vse te toke, samo da imajo Y <= Y0.  Leva stranica je
  pri tem ves as na (X0, Y0), nato pa gremo po vseh
  tokah iz N, da vidimo, katere so v [X0, X0 + A] x [Y, Y + B]. }
  
const MaxN = 10000; 
type 
  TabelaI = array[1..MaxN] of integer; 
  TabelaR = array[1..MaxN] of real; 
var
  PtX, PtY: ^TabelaR;   { koordinate tok } 
  N: integer;           { tevilo tok } 
  A, B: real;           { velikost poizvedovalnega okna } 
  Neigh: ^TabelaI; nNeigh: integer;   { okolica toke (X0, Y0) } 
  i, j, k, Count, Best: integer; F: text;  
  X0, Y0, Y1, YCur: real; 
begin

  { Preberimo vhodne podatke. } 
  New(PtX); New(PtY); 
  if ParamCount >= 1 then Assign(F, ParamStr(1))
  else Assign(F, 'input.txt'); 
  Reset(F); ReadLn(F, A, B); ReadLn(F, N); 
  for i := 1 to N do ReadLn(F, PtX^[i], PtY^[i]);  
  Close(F); 
  
  { Pojdimo po vseh tokah. } 
  Best := 0; New(Neigh);  
  for i := 1 to N do begin 

    { Pregledali bomo pravokotnike z i-to toko, (X0, Y0), na levi stranici.
      V Neigh pripravimo toke z X0 <= X <= X0 + A, Y0 - B <= Y <= Y0 + B; 
      samo te lahko namre leijo v kaknem takem pravokotniku. }
    X0 := PtX^[i]; Y0 := PtY^[i]; nNeigh := 0;  
    for j := 1 to N do 
      if   (X0 <= PtX^[j])     and (PtX^[j] <= X0 + A) 
      and  (Y0 - B <= PtY^[j]) and (PtY^[j] <= Y0 + B) 
      then begin Inc(nNeigh); Neigh^[nNeigh] := J; end;

    { Poskusimo vse mone poloaje spodnje stranice pravokotnika. } 
    for j := 1 to nNeigh do begin 
      Count := 0; Y1 := PtY^[Neigh^[j]]; 
      if Y1 > Y0 then continue;
      { Koliko tok pokriva pravokotnik s spodnjo stranico pri Y1? } 
      for k := 1 to nNeigh do begin 
        YCur := PtY^[Neigh^[k]]; 
        if (Y1 <= YCur) and (YCur <= Y1 + B) then Inc(Count); 
      end; {for k} 
      if Count > Best then Best := Count; 
    end; {for j} 

  end; {for i} 

  { Izpiimo rezultat in poistimo pomnilnik. } 
  if ParamCount >= 2 then Assign(F, ParamStr(2))
  else Assign(F, 'output.txt'); 
  Rewrite(F); WriteLn(F, Best); Close(F); 
  Dispose(Neigh); Dispose(PtX); Dispose(PtY); 
end. {Rozine1} 
