program VrsticniUrejevalnik; { RTK 1998.1.2 }
uses Crt;
var S, Zbrisano: string; P, MaxDolz: integer;

procedure PrikaziStanje;
var i: integer;
begin
  WriteLn(S);
  for i := 1 to P - 1 do Write(' ');
  WriteLn('^');
end; {PrikaziStanje}

type UkazT = (BrisiZacetek, BrisiKonec, BrisiZnak, 
              VriniZbrisano, VriniPresledek, Levo, Desno,
              NaKonecPrejsnjeBesede, NaZacetekNaslednjeBesede);

procedure Izvedi(Ukaz: UkazT; Kolikokrat: integer);
const ImeUkaza: array[UkazT] of string = ('BrisiZacetek',
  'BrisiKonec', 'BrisiZnak', 'VriniZbrisano', 'VriniPresledek',
  'Levo', 'Desno', 'NaKonecPrejsnjeBesede', 'NaZacetekNaslednjeBesede');
var i: integer;
begin
  { Izpiimo ukaz. }
  for i := 1 to Length(S) + 2 do Write(' ');
  if Kolikokrat > 1 then Write(Kolikokrat, ' ');
  WriteLn(ImeUkaza[Ukaz]);
  { Izvedimo ukaz. }
  for i := 1 to Kolikokrat do begin
    case Ukaz of
      BrisiZacetek: begin 
        Zbrisano := Copy(S, 1, P - 1);
        S := Copy(S, P, Length(S) - P + 1); P := 1; end;
      BrisiKonec: begin
        Zbrisano := Copy(S, P, Length(S) - P + 1);
        S := Copy(S, 1, P - 1); end;
      BrisiZnak:
        if P < Length(S) then begin
          Zbrisano := S[P];
          S := Copy(S, 1, P - 1) + Copy(S, P + 1, Length(S) - P);
        end; {if}
      VriniZbrisano: begin
        S := Copy(S, 1, P - 1) + Zbrisano + Copy(S, P, Length(S) - P + 1);
        P := P + Length(Zbrisano); end;
      VriniPresledek: begin
        S := Copy(S, 1, P - 1) + ' ' + Copy(S, P, Length(S) - P + 1);
        P := P + 1; end;
      Desno:
        if P <= Length(S) then P := P + 1;
      Levo:
        if P > 1 then P := P - 1;
      NaZacetekNaslednjeBesede: begin
        while P <= Length(S) do if S[P] = ' ' then break else P := P + 1;
        while P <= Length(S) do if S[P] = ' ' then P := P + 1 else break; end;
      NaKonecPrejsnjeBesede: begin
        if P > Length(S) then begin P := P - 1; if P < 1 then P := 1; end
        else while P >= 1 do if S[P] = ' ' then break else P := P - 1;
        while P >= 1 do if S[P] = ' ' then P := P - 1 else break; end;
    end; {case}
    if Length(S) > MaxDolz then S := Copy(S, 1, MaxDolz);
    if P > MaxDolz + 1 then P := MaxDolz + 1;
  end; {for}
  { Izpiimo novo stanje. }
  PrikaziStanje;
end; {Izvedi}

procedure PrestaviPrvoBesedoNaKonecVrstice;
begin
  Izvedi(NaZacetekNaslednjeBesede, 1);
  Izvedi(BrisiZacetek, 1);
  Izvedi(Desno, 1000);
  Izvedi(VriniPresledek, 1);
  Izvedi(VriniZbrisano, 1);
end; {PrestaviPrvoBesedoNaKonecVrstice}

procedure PoravnajVrsticoDesno;
const ZacSirina = 70; KonSirina = 80;
begin
  Izvedi(VriniPresledek, KonSirina);    { Vrinimo 80 presledkov na zaetku. }
  Izvedi(Desno, ZacSirina);             { Pojdimo na konec vrstice. }
  Izvedi(Levo, KonSirina);              { Obdrali bomo zadnjih 80 znakov... }
  Izvedi(BrisiZacetek, 1);              { ...odvene presledke pa pobrisali. }
end; {PoravnajVrsticoDesno}

{ Previdneja reitev, ki predpostavi, da urejevalnik mogoe
  ne dovoli ve kot KonSirina znakov v eni vrstici in da
  pri vrivanju znakov ree znake s konca vrstice, e bi le-ta
  postala predolga. }
procedure PoravnajVrsticoDesno2;
const ZacSirina = 70; KonSirina = 80;
begin
  Izvedi(Desno, ZacSirina);             { Pojdimo na konec vrstice. }
  Izvedi(VriniPresledek, KonSirina);    { Vrinimo 80 presledkov. }
  Izvedi(Levo, ZacSirina + KonSirina);  { Pojdimo na zaetek vrstice. }
  Izvedi(Desno, KonSirina);             { Preskoimo prvih 80 znakov. }
  Izvedi(BrisiKonec, 1);                { Zbriimo odvene presledke. }
  Izvedi(NaKonecPrejsnjeBesede, 1);     { Pojdimo do zadnjega znaka prvotne vrstice. }
  Izvedi(Desno, 1);                     { Pojdimo na prvi presledek za prvotno vsebino. }
  Izvedi(BrisiKonec, 1);                { Te presledke bo treba premakniti na zaetek vrstice. }
  Izvedi(Levo, 70);                     { Pojdimo na zaetek vrstice. }
  Izvedi(VriniZbrisano, 1);             { Vrinimo presledke, ki smo jih prej zbrisali. }
end; {PoravnajVrsticoDesno}

procedure LepoOblikujStevilo;
begin
  Izvedi(Desno, 8);                     { Pojdimo na konec vrstice. }
  Izvedi(Levo, 3);                      { Desne tri tevke. }
  Izvedi(VriniPresledek, 1);            { Presledek pred stoticami. }
  Izvedi(Levo, 4);                      { Pojdimo mimo presledka in naslednjih treh tevk. }
  Izvedi(VriniPresledek, 1);            { Presledek pred stotisoicami. }
  Izvedi(Levo, 3);                      { Pojdimo mimo presledka in naslednjih dveh tevk. }
  Izvedi(VriniPresledek, 1);            { Vrinimo e en presledek pred tevilom. }
  Izvedi(Levo, 1);                      { Postavimo se na ta presledek. }
  Izvedi(NaZacetekNaslednjeBesede, 1);  { Premaknimo se na prvo tevko. }
  Izvedi(BrisiZacetek, 1);              { Pobriimo odvene presledke na zaetku vrstice. }
end; {LepoOblikujStevilo}

procedure Pomoc;
begin
  WriteLn;
  WriteLn('S pritiski na tipke lahko izvaja ukaze in podprograme: ');
  WriteLn('(L)evo, (D)esno, (B)rii znak, brii (Z)aetek, brii (K)onec,');
  WriteLn('(V)rini zbrisano, vrini( )presledek, ');
  WriteLn('na zaetek (N)aslednje / konec (P)rejnje besede.  (Q) = izhod iz programa.');
  WriteLn('1 = prestavi prvo besedo na konec vrstice');
  WriteLn('2 = poravnaj vrstico desno;');
  WriteLn('3 = poravnaj vrstico desno (previdneja reitev);');
  WriteLn('4 = lepo oblikuj tevilo.');
  WriteLn;
  PrikaziStanje;
end;

var c: char;
begin {VrsticniUrejevalnik}
  WriteLn('Vnesi vrstico besedila: ');
  ReadLn(S); P := 1; Zbrisano := '';
  WriteLn('Vnesi najvejo dovoljeno dolino vrstice (urejevalnik ree');
  Write('znake s konca vrstice, e/ko bi le-ta postala predolga): ');
  ReadLn(MaxDolz);
  Pomoc;
  while true do begin
    c := UpCase(ReadKey);
    if c = #0 then begin
      c := ReadKey;
      case c of
      #77: Izvedi(Desno, 1);
      #75: Izvedi(Levo, 1);
      #83: Izvedi(BrisiZnak, 1);
      else WriteLn(0, ' ', Ord(c));
      end
    end else
      case c of
      'L': Izvedi(Levo, 1);
      'D': Izvedi(Desno, 1);
      'B': Izvedi(BrisiZnak, 1);
      'Z': Izvedi(BrisiZacetek, 1);
      'K': Izvedi(BrisiKonec, 1);
      ' ': Izvedi(VriniPresledek, 1);
      'V': Izvedi(VriniZbrisano, 1);
      'N': Izvedi(NaZacetekNaslednjeBesede, 1);
      'P': Izvedi(NaKonecPrejsnjeBesede, 1);
      '1': PrestaviPrvoBesedoNaKonecVrstice;
      '2': PoravnajVrsticoDesno;
      '3': PoravnajVrsticoDesno2;
      '4': LepoOblikujStevilo;
      'Q', 'X', 'E', 'I': break;
      'H', '?': Pomoc;
      else WriteLn(Ord(c));
      end; {case}
  end; {while}
end. {VrsticniUrejevalnik}
