program StetjeKvadratov; { RTK 1998.2.1 }
const MaxTock = 1000; MaxKoord = 20000;
var
  StTock: integer;
  x, y: array[1..MaxTock] of integer; 

  { Naivna reitev O(n^2). }
  function Algoritem1: integer;
  var i, j, s: integer; 
  begin
    s := 0; 
    for i := 1 to StTock - 1 do 
      for j := i + 1 to StTock do 
        if x[j] - x[i] = y[j] - y[i] then 
          s := s + 1; 
    Algoritem1 := s;
  end; {Algoritem1}

  { Reitev, ki za vsako toko izrauna x - y.  e k tok
    dobi isto vrednost x - y, tvorijo 1 + 2 + ... + (k-1) kvadratov.
    asovna zahtevnost: O(n). }
  function Algoritem2: integer;
  var i, j, s: integer; a: array[-MaxKoord..MaxKoord] of integer; 
  begin
    for j := -MaxKoord to MaxKoord do a[j] := 0; 
    s := 0; 
    for j := 1 to StTock do begin 
      i := x[j] - y[j]; 
      s := s + a[i];  
      a[i] := a[i] + 1;  
    end; {for}
    Algoritem2 := s;
  end; {Algoritem2}

var j, Alg: integer; 
    T: text;
begin {StetjeKvadratov}
  if ParamCount >= 2 then Assign(T, ParamStr(2))
  else Assign(T, 'rtk98s2n1.in');
  Reset(T);

  Alg := 1;
  if ParamCount >= 1 then Val(ParamStr(1), Alg, j);
  
  while not Eof(T) do begin
    ReadLn(T, StTock);
    if StTock <= 0 then break;
    for j := 1 to StTock do ReadLn(T, x[j], y[j]);
  
    Write('(Algoritem ', Alg, ')  tevilo kvadratov: ');
    if Alg = 1 then WriteLn(Algoritem1)
    else WriteLn(Algoritem2);
  end; {while}

  Close(T);
end. {StetjeKvadratov}

{ Meritve na tirih nakljuno zgeneriranih mnoicah
  tok (30, 300, 1000, 1000):
  - Algoritem 1: 0.080 s
  - Algoritem 2: 0.018 s
  (Povpreje petih zagonov, procesor PIII 800 MHz.) }
