program NajdaljsaPot; { RTK 2000.3.2 }
{ Glede oblike vhodnih in izhodnih podatkov se ta
  program dri navodil s tekmovanja CERC 1999:
  http://contest.felk.cvut.cz/99cerc/problems.html#labyrinth }

const MaxW = 1000; MaxH = 1000;
type PoljeSmer = (Prosto, Zid, Gor, Dol, Levo, Desno); 
const NaspSmer: array[Gor..Desno] of Gor..Desno = (Dol, Gor, Desno, Levo);
      DX: array[Gor..Desno] of integer = (0, 0, -1, 1);
      DY: array[Gor..Desno] of integer = (-1, 1, 0, 0);
var 
  Lab: packed array[1..MaxH, 1..MaxH] of PoljeSmer; 
  Glob, Dolz: array[1..MaxH, 1..MaxW] of integer; 
  N, W, H, x, y, xx, yy, x0, y0, G, G2, D: integer; 
  c: char; b: boolean; s: PoljeSmer;
begin
  ReadLn(N); { tevilo testnih primerov }
  while N > 0 do begin
    N := N - 1; ReadLn(W, H); { velikost labirinta }

    { Preberimo opis labirinta. }
    for y := 1 to H do begin
      for x := 1 to W do begin 
        Read(c); 
        if c = '#' then Lab[y, x] := Zid 
        else begin Lab[y, x] := Prosto; x0 := x; y0 := y; end;
      end; {for x}
      ReadLn;
    end; {for y}

    { Zdaj bomo izvedli iskanje v globino z zaetkom na (x0, y0).
      Spotoma bomo tudi raunali vrednosti Glob in Dolz za vsako
      prosto polje.  Vrstni red iskanja v globino doloa tudi
      relacijo med stari in otroci v drevesu.  Ko prvi pridemo
      v neko polje, zapiemo v Lab[y, x] smer, iz katere smo prili. }
    x := x0; y := y0; Lab[y, x] := Zid;
    while true do begin
      { Ali ima trenutno polje, (x, y), e kaj 
        neobiskanih prostih sosedov? }
      b := false;
      for s := Gor to Desno do begin
        xx := x + DX[s]; yy := y + DY[s];
        if (xx < 1) or (yy < 1) or (xx > W) or (yy > H) then continue;
        { Je to sosednje polje prosto in e neobiskano? }
        if Lab[yy, xx] <> Prosto then continue;
        { Postavimo se vanj in si zapomnimo, od kod smo prili. }
        Lab[yy, xx] := NaspSmer[s]; 
        x := xx; y := yy; b := true; break;
      end; {for s}
      if b then continue; { Premaknili smo se v enega od otrok. }

      { e pride izvajanje do sem, pomeni, da smo pregledali
        e vse otroke trenutnega poloaja.  Zdaj lahko iz njihovih
        vrednosti Glob in Dolz izraunamo to dvoje e za (x, y). 
        V smeri Lab[y, x] je na roditelj, v ostalih smereh pa otroci. }
      G := 0; G2 := 0; D := 0;
      for s := Gor to Desno do if s <> Lab[y, x] then begin
        xx := x + DX[s]; yy := y + DY[s];
        if (xx < 1) or (yy < 1) or (xx > W) or (yy > H) then continue;
        if Lab[yy, xx] = Zid then continue;
        if Dolz[yy, xx] > D then D := Dolz[yy, xx];
        if Glob[yy, xx] > G then begin G2 := G; G := Glob[yy, xx] end
        else if Glob[yy, xx] > G2 then G2 := Glob[yy, xx];
      end; {for s}

      { Globina stara = 1 + globina najglobljega poddrevesa. }
      Glob[y, x] := G + 1;
      { En kandidat za najdaljo pot je taka, ki gre skozi trenutni poloaj, 
        pred in za tem pa karseda globoko v najgloblji dve poddrevesi. 
        Drugi kandidat je najdalja pot, ki je v celoti v enem od poddreves. }
      if G + G2 < D then Dolz[y, x] := D else Dolz[y, x] := G + G2;

      { Vrnimo se zdaj v naega stara.  Zanj smo v zadnji zanki po s
        ugotovili, da lei v smeri ps glede na trenutni poloaj. 
        e pa je trenutni poloaj koren drevesa (ki stara nima),
        je to znak, da smo pregledali ves labirint in lahko nehamo. }
      if (x = x0) and (y = y0) then break;
      s := Lab[y, x]; x := x + DX[s]; y := y + DY[s];

    end; {while}
    WriteLn('Maximum rope length is ', Dolz[y0, x0], '.');
  end; {while}
end. {NajdaljsaPot}
