program PitagorejskeTrojice; { RTK 2001.1.4 }
var n, x, y, z, a, b: integer; 
begin
  if ParamCount >= 2 then begin
    Val(ParamStr(1), a, n); Val(ParamStr(2), b, n);
  end else begin
    Write('Vnesi a in b: '); ReadLn(a, b);
  end; {if}
  n := 0; 
  for z := a to b do begin 
    { Pitagorejskih trojic (x, y, z), pri katerih bi bila 
      ena od katet 1, ni (potem bi bilo y^2 = z^2 - 1;
      ker morata biti y in z cela, sledi y <= z - 1 in
      zato z^2 - 1 = y^2 <= z^2 - 2z + 1, kar pomeni
      2z = 2, z = 1, toda potem bi bil y = 0, naloga pa
      hoe pozitivna tevila).  Zato bomo zaeli pri x = 2. }
    x := 2; y := z - 1; 
    while x < y do begin 
      { Invarianta: nateli smo e vse trojice (X, Y, z),
        ki imajo X < x in/ali y < Y. }
      if x * x + y * y > z * z then 
        { Vse pare (X, y) z X < x smo e upotevali (kot pravi
          zanna invarianta), tisti z X = x bi dal predolgo
          hipotenuzo (kot pravi pogoj tega stavka if), 
          tisti z X > x pa so potemtakem e bolj preveliki.
          Torej pri trenutnem y ne bomo dobili nobene 
          pitagorejske trojice ve; zato lahko y zmanjamo za 1. }
        y := y - 1 
      else begin 
        if x * x + y * y = z * z then n := n + 2; 
        { Vse pare (x, Y) z Y > y smo e upotevali (kot pravi
          zanna invarianta).  Tisti z Y = y pa ustreza pogoju
          x * x + y * y <= z * z (e bi bilo >, bi se izvedel
          prvi stavek if zgoraj in mi zdaj ne bi bili tule);
          e velja =, smo to upotevali v prejnjem stavku in
          primerno poveali n.  V vsakem primeru pa to pomeni,
          da bi Y < y dal premajhno levo stran (prekratko
          hipotenuzo).  Zato pri trenutnem x ne bomo dobili
          nobene pitagorejske trojice ve; x lahko poveamo za 1. }
        x := x + 1; 
      end; {if} 
    end; {while}
    { Zdaj je x = y.  Vse trojice z X < Y smo upotevali; 
      tiste z Y < X smo upotevali zato, ker smo prve teli
      dvojno; takih z X = Y pa sploh ni, ker bi bil potem
      z = X * sqrt(2) iracionalno tevilo, ne pa celo. }
  end; {for}
  WriteLn('t. pitagorejskih trojic za ', a, ' <= z <= ', b, ': ', n); 
end. {PitagorejskeTrojice} 
