program PsevdoTetris; { RTK 2001.2.2 }
{ Ta program rei malo sploneji problem, kot ga zahteva
  naloga RTK 2001.2.2.  Posploitev je v tem, da namesto
  enega samega kvadratka skozi igralno povrino
  poiljamo nek lik, ki je lahko tudi veji in bolj 
  zapletene oblike.  Natanen opis naloge je na:
  http://contest.felk.cvut.cz/99cerc/problems.html,
  naloga "Proper Key". 
    Spodnja reitev temelji na naslednji zamisli: e se bo
  pri premiku lika v levo kakno polje zaletelo v eno od
  polnih polj igralne povrine, bo to gotovo neko tako polje,
  ki ima v definiciji lika na svoji levo prazno polje.
  Enako lahko razmiljamo tudi pri premikih desno in dol.
  Zato si ob branju lika pripravimo sezname takih "robnih"
  polj naega lika (tabele Leva, Desna in Spodnja). 
    Opis problema na CERC 1999 ima tudi zagotovilo, da
  je lik povezan (sestavljen iz enega samega dela)
  in da ostane povezan, tudi e mu na vrhu odreemo 
  nekaj vrstic.  Spodnji program je malo sploneji, ker
  se na to zagotovilo ne opira in deluje tudi, e to
  ne velja.  V datoteki rtk01s2n2.in, ki je priloena
  temu programu, je med drugim tudi en testni primer, 
  pri katerem to zagotovilo ne velja. }

const
  MaxR = 100; { najveja viina lika }
  MaxC = 100; { najveja irina lika }
  MaxW = 1000; { najveja irina igralne povrine }
type
  RobnaPoljaT = array[1..MaxR * MaxC] of integer;
var
  { Polno[y, x] pove, e je to polno.  Ker nikoli ni treba
    gledati ve kot R vrstic igralne povrine naenkrat, ima ta
    tabela le MaxR vrstic, ne pa MaxD.  Tako lahko prihranimo
    precej pomnilnika. Indeks vrstice v tej tabeli bo el od 0
    naprej namesto od 1 naprej, da bomo laje raunali po modulu R. }
  Polno: array[0..MaxR - 1, 1..MaxW] of boolean;
  y: integer; { trenutna vrstica }
  R, C, D, W: integer; { velikost lika in igralne povrine }

  { Preveri, e bi se ob premiku lika na koordinato x 
    (torej tako, da bi bil najbolj desni stolpec lika na koordinati x)
    kakno od robnih polj iz tabele Robna zaletelo v kakno
    od polnih polj igralne povrine. }
  function SeLahkoPremakne(var Robna: RobnaPoljaT; nR, x: integer): boolean;
  var i, xx, yy: integer;
  begin
    SeLahkoPremakne := true;
    for i := 1 to nR do begin
      xx := x - C + 1 + Robna[i] mod C; 
      yy := y - R + 1 + Robna[i] div C;
      if (yy <= 0) or (yy > D) then continue;
      if Polno[yy mod R, xx] then 
        begin SeLahkoPremakne := false; exit; end;
    end; {for i}
  end; {SeLahkoPremakne}

var
  S, S1: string; 
  var x, xx, i, StPrimerov, Odgovor: integer;
  { Robna polja naega lika.  Polje (x, y) je predstavljeno
    z vrednostjo (x - 1) + R * (y - 1). }
  Leva, Desna, Spodnja: RobnaPoljaT;
  nLevih, nDesnih, nSpodnjih: integer;
  { Dosegljivo[x] pove, e je mogoe lik spraviti v tak poloaj, 
    da je njegov spodnji desni kot v polju x trenutne vrstice. }
  Dosegljivo: array[1..MaxW] of boolean;
  
begin
  ReadLn(StPrimerov);
  while StPrimerov > 0 do begin
    Dec(StPrimerov);
    ReadLn(R, C);
    nLevih := 0; nDesnih := 0; nSpodnjih := 0;
    { Preberimo opis lika.  Zapomnili si bomo, katera 
      zasedena polja imajo levo, desno ali spodaj prosto polje. 
      Nad likom si mislimo prazno vrstico. }
    S := ''; for x := 1 to C + 2 do S := S + '.';
    for y := 1 to R + 1 do begin
      S1 := S; { Dosedanjo vrstico si zapomnimo v S1. }
      if y <= R then ReadLn(S) { Preberimo naslednjo vrstico. }
      else { Mislimo si, da je pod likom e ena prazna vrstica. }
        begin S := ''; for x := 1 to C do S := S + '.'; end;
      S := '.' + S + '.'; { e dva znaka za straarja. }
      for x := 1 to C do begin
        if S[x + 1] = '#' then begin
          if S[x] = '.' then begin Inc(nLevih); Leva[nLevih] := (y - 1) * C + (x - 1); end;
          if S[x + 2] = '.' then begin Inc(nDesnih); Desna[nDesnih] := (y - 1) * C + (x - 1); end;
        end else
          if S1[x + 1] = '#' then begin Inc(nSpodnjih); Spodnja[nSpodnjih] := (y - 2) * C + (x - 1); end;
      end; {for x}
    end; {for y}
    { Zdaj bomo pregledali igralno povrino. }
    ReadLn(D, W);
    { e je spodnja vrstica lika cela nad igralno povrino, 
      je dosegljiva vsaka x-koordinata. }
    for x := 1 to W do Dosegljivo[x] := true;
    Odgovor := 0;
    { Berimo igralno povrino in glejmo, do kod lahko lik pride. }
    for y := 1 to R + D do begin
      if y <= D then begin
        { Preberimo naslednjo vrstico igralne povrine. }
        x := 0;
        repeat
          Read(S);
          for i := 1 to Length(S) do Polno[y mod R, x + i] := S[i] = '#';
          Inc(x, Length(S));
        until x >= W;
        ReadLn;
      end;
      { Poskusimo premakniti lik navzdol. }
      for x := C to W do if Dosegljivo[x] then 
        Dosegljivo[x] := SeLahkoPremakne(Spodnja, nSpodnjih, x);
      { Poskusimo premakniti lik levo in desno. }
      for x := C to W do if Dosegljivo[x] then begin
        xx := x - 1; while xx >= C do 
          if Dosegljivo[xx] then break
          else if not SeLahkoPremakne(Leva, nLevih, xx) then break
          else begin Dosegljivo[xx] := true; Dec(xx); end;
        xx := x + 1; while xx <= W do 
          if Dosegljivo[xx] then break
          else if not SeLahkoPremakne(Desna, nDesnih, xx) then break
          else begin Dosegljivo[xx] := true; Dec(xx); end;
      end; {for x}
      { e je kak poloaj v tej vrstici dosegljiv, popravimo Odgovor. }
      for x := C to W do if Dosegljivo[x] then 
        begin Odgovor := y; break; end;
      { e so v neki vrstici vsi poloaji nedosegljivi, bo enako tudi
        v kasnejih vrsticah.  Zato bi lahko naeloma takoj nehali,
        vendar pa moramo vsaj igralno povrino vendarle prebrati do konca. }
      if (y >= D) and (Odgovor < y) then break;
    end; {for y}
    if Odgovor = R + D then WriteLn('The key can fall through.')
    else WriteLn('The key falls to depth ', Odgovor, '.');
  end; {while StPrimerov > 0}
end. {PsevdoTetris}
