program SimulatorPredalcka; { RTK 2001.2.3 }
uses Crt;

  { Vmesnik, ki ga vidi podprogram za upravljanje predalka. }
  type SmerT = (Stop, Noter, Ven); 
  function TipkaPritisnjena: boolean; forward; 
  function Odprto: boolean; forward; 
  function Zaprto: boolean; forward; 
  procedure Motor(IzbranaSmer: SmerT); forward; 

{ Podprogram za upravljanje s predalkom.
  Tega so morali napisati tekmovalci. }
procedure MotoriziraniPredalcek; 
var IzbranaSmer, TrenutnaSmer: SmerT; 
    TipkaNovo, TipkaStaro: boolean; 
    Pogon: boolean; 
begin {MotoriziraniPredalcek} 
  IzbranaSmer := Noter; TrenutnaSmer := Noter; 
  TipkaStaro := false; 
  Motor(Stop); Pogon := false; 
  repeat 
  
    TipkaNovo := TipkaPritisnjena; 
    if TipkaNovo > TipkaStaro then begin
      { Zaetek pritiska tipke: obrnimo izbrano smer. } 
      if IzbranaSmer = Noter then IzbranaSmer := Ven 
                             else IzbranaSmer := Noter; 
    end; {if}
    TipkaStaro := TipkaNovo; 
    
    if ((TrenutnaSmer = Noter) and Pogon and Zaprto) or 
       ((TrenutnaSmer = Ven)   and Pogon and Odprto) then
      begin Motor(Stop); Pogon := false; end; { Zaustavitev v konni legi. }
      
    if (IzbranaSmer <> TrenutnaSmer) or 
       not (Zaprto or Odprto or Pogon) then begin
      { Sprememba smeri, ali pa ustavljeno v vmesni legi:
        vkljuimo pogon v pravo smer. } 
      Motor(IzbranaSmer); Pogon := true; 
      TrenutnaSmer := IzbranaSmer; 
    end; {if}
  until false; 
end; {MotoriziraniPredalcek} 

{-----------------------------------------------------------------------------}
{ Preostanek programa deluje kot simulator predalka.
  Uporabnik lahko s pritiskom na tipko 1 pritisne tipko "Odpri/Zapri",
  s pritiskom na tipko 2 jo spusti, s pritiskom na 0 pa kona
  z izvajanjem programa.  Program med tem na zaslon prikazuje
  stanje predalka. }
{-----------------------------------------------------------------------------}
  
const
  MaxPolozaj = 1000; { poloaj, v katerem je predalek povsem odprt }
  HitrostMotorja = 1; { za koliko enot se spremeni poloaj predalka
    v asu zakasnitve, ki jo vsebuje funkcija TipkaPritisnjena }
var 
  SmerMotorja: SmerT; { Trenutno stanje motorja. }
  Polozaj: integer; { poloaj predalka; 0 = povsem zaprt }
  Pritisnjena: boolean; { Stanje tipke. }
  Cas: longint;

procedure PrikaziStanje;
const StZnakov = 30; { ASCII-art prikaz predalka :) }
var n, i: integer;
begin
  Write('Tipka ');
  if Pritisnjena then Write('pritisnjena,')
  else Write('spuena,   ');
  Write(' motor ');
  case SmerMotorja of
    Noter: Write('<'); Ven: Write('>'); else Write('|');
  end; {case}
  Write('  ', Polozaj:5, ' |');
  n := Round(StZnakov * Polozaj / (1.0 * MaxPolozaj));
  for i := 1 to n - 1 do Write('_');
  if n > 0 then Write(',');
  for i := n to StZnakov do Write(' ');
  Write(Chr(13));
end; {Pocakaj1ms}

function TipkaPritisnjena: boolean;
begin
  { Podprogram za krmiljenje predalka naj bi tole funkcijo
    TipkaPritisnjena klical v nekakni zanki in vmes naj sam
    ne bi porabil kaj dosti asa.  Zato bomo izkoristili to
    prilonost za popravljanje poloaja predalka in 
    prikaz stanja na zaslon. }
  Inc(Cas);
  if (Cas mod 3) = 0 then Delay(1);
  { Premik predalka. }
  if SmerMotorja = Noter then Dec(Polozaj, HitrostMotorja)
  else if SmerMotorja = Ven then Inc(Polozaj, HitrostMotorja);
  if Polozaj < 0 then Polozaj := 0
  else if Polozaj > MaxPolozaj then Polozaj := MaxPolozaj;
  { Poglejmo, e je uporabnik pritisnil ali spustil tipko. }
  if KeyPressed then 
    case ReadKey of
    '1': Pritisnjena := true;
    '2': Pritisnjena := false;
    '0': begin WriteLn; Halt; end;
    end; {case}
  TipkaPritisnjena := Pritisnjena;
  { Obasno osveimo prikaz stanja. }
  if Cas mod 100 = 0 then PrikaziStanje;
end; {TipkaloPritisnjeno}

function Odprto: boolean;
  begin Odprto := Polozaj = MaxPolozaj; end;

function Zaprto: boolean;
  begin Zaprto := Polozaj = 0; end;

procedure Motor(IzbranaSmer: SmerT);
begin
  SmerMotorja := IzbranaSmer;
end; {Izklopi}

begin {SimulatorPredalcka}
  WriteLn('Simulacija predalka na predvajalniku CDjev');
  WriteLn('Tipka 1 pritisne tipko "Odpri/Zapri" ob predalku,');
  WriteLn('tipka 2 jo spusti, tipka 0 kona simulacijo.');
  Cas := 0; Polozaj := Random(MaxPolozaj + 1);
  SmerMotorja := SmerT(Random(3));
  Pritisnjena := false;
  PrikaziStanje; { zaetno stanje }
  MotoriziraniPredalcek; { poenimo simulacijo }
end. {SimulatorPredalcka}
