program Hilbert; { RTK 2002.3.7 }

  function Encode(k, x, y: longint): longint;
  var h, j: longint;
  begin
    if k = 0 then begin Encode := 0; exit; end;
    h := 1 shl (k - 1); j := h * h;
    if (x < h) and (y < h) then Encode := Encode(k - 1, y, x)
    else if (x < h) then Encode := j + Encode(k - 1, x, y - h)
    else if (y < h) then Encode := 3 * j + Encode(k - 1, h - 1 - y, 2 * h - 1 - x)
    else Encode := 2 * j + Encode(k - 1, x - h, y - h);
  end; {Encode}
  
  procedure Decode(k, i: longint; var x, y: longint);
  var h, j, xx, yy: longint;
  begin
    if k = 0 then begin x := 0; y := 0; exit; end;
    h := 1 shl (k - 1); j := h * h; Decode(k - 1, i mod j, xx, yy);
    if i < j then begin x := yy; y := xx; end
    else if i < 2 * j then begin x := xx; y := yy + h; end
    else if i < 3 * j then begin x := xx + h; y := yy + h; end
    else begin x := 2 * h - 1 - yy; y := h - 1 - xx; end;
  end; {Decode}

var T: text; k, a, b: longint;
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'produkt.in'); 
  Reset(T); ReadLn(T, k, a, b); Close(T);
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'produkt.out'); 
  Rewrite(T); 
  if a >= 0 then WriteLn(T, Encode(k, a, b))
  else begin Decode(k, b, a, b); WriteLn(T, a, ' ', b); end;
  Close(T);
end. {Hilbert}
