program Slovar; { RTK 2002.3.8 }
const 
  MinDolz = 2; MaxDolz = 10; 
  MaxN = 10000; MaxStopnja = 30;
  MaxSkupDolz = 55000;
  RazpMax = 10037; { primerno veliko pratevilo }
type 
  SosedeT = packed array[1..MaxStopnja * MaxN] of integer;
  SosedeP = ^SosedeT;
var 
  T, TT: text; S, S1, S2: string;
  i, i2, j, k, d, dNasl, iOd, iDo, Izp, L, N, hc, Prehod, StPrimerov: integer;
  { rke vseh besed, zbite skupaj v eno dolgo tabelo; besedi
    i pripadajo Crke[PrvaCrka[i]..PrvaCrka[i] + Dolzina[i] - 1]. }
  Crke: packed array[1..MaxSkupDolz + MaxDolz] of char; 
  PrvaCrka, Dolzina: array[0..MaxN] of word;
  { Sosede[d] kae na tabelo s seznami sosed za vse besede doline d;
    teh sosed je vsega skupaj SkupajSosed[d].  Sosede besede i so v celicah 
    Sosede[Dolzine[i]]^[PrvaSoseda[i]..PrvaSoseda[i] + StSosed[i] - 1]. }
  Sosede: array[MinDolz..MaxDolz] of SosedeP; 
  SkupajSosed: array[MinDolz..MaxDolz] of word;
  StSosed, PrvaSoseda: array[0..MaxN] of word;
  { Razprena tabela (za laje odkrivanje enakih besed).  Reze[hc]
    kae na prvo besedo z razprilno kodo hc; e je to beseda i,
    kae potem Verige[i] na naslednjo, Verige[Verige[i]] na e 
    naslednjo in tako naprej.  Konec verige oznauje indeks 0. }
  Reze: array[0..RazpMax - 1] of integer; 
  Verige: array[1..MaxN] of integer;
  { Vrsta za iskanje v irino.  Trenutna beseda je na oddaljenosti
    d od zaetne besede, tiste, ki so v vrsti od indeksa dNasl naprej,
    pa so e na oddaljenosti d + 1. }
  Vrsta, Obiskana: array[1..MaxN] of integer; Glava, Rep: integer;
  
  { Izrauna razprilno kodo dane besede (z eno izpueno rko).
    Takno kodo se lahko uporabi kot indeks v tabelo Reze. }
  function Razprsi(StBesede, IzpuscenaCrka: integer): integer;
  var r: longint; i: integer;
  begin
    r := 0; for i := 1 to Dolzina[StBesede] do if i <> IzpuscenaCrka then
      r := (r * 256 + Ord(Crke[PrvaCrka[StBesede] + i - 1])) mod RazpMax;
    Razprsi := r;
  end; {Razprsi}
  
  function Enaki(StBesede1, StBesede2, IzpuscenaCrka: integer): boolean;
  var i: integer;
  begin
    Enaki := false; if Dolzina[StBesede1] <> Dolzina[StBesede2] then exit;
    for i := 1 to Dolzina[StBesede1] do if i <> IzpuscenaCrka then
      if Crke[PrvaCrka[StBesede1] + i - 1] <> Crke[PrvaCrka[StBesede2] + i - 1] then exit;
    Enaki := true;
  end; {Enaki}
  
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'slovar.in'); 
  Reset(T); ReadLn(T, N); 
  { Preberimo slovar. }
  for i := 1 to N do begin
    ReadLn(T, S); L := Length(S); Dolzina[i] := L; 
    if i = 1 then PrvaCrka[i] := 1 
    else PrvaCrka[i] := PrvaCrka[i - 1] + Dolzina[i - 1];
    for j := 1 to L do Crke[PrvaCrka[i] + j - 1] := S[j];
  end; {for i}
  { Za vsako besedo pripravimo seznam sosed.  To naredimo v dveh
    prehodih; najprej bomo sosede samo preteli, v drugem prehodu
    pa jih bomo zapisali v tabele Sosede. }
  for Prehod := 1 to 2 do begin
    for i := 1 to N do StSosed[i] := 0;
    for d := MinDolz to MaxDolz do for Izp := 1 to d do begin
      { Zanimo s prazno razpreno tabelo. }
      for i := 0 to RazpMax - 1 do Reze[i] := 0;
      for i := 1 to N do Verige[i] := 0;
      { Preglejmo vse besede doline d. }
      for i := 1 to N do if Dolzina[i] = d then begin
        { V razpreni tabeli poglejmo, katere se ujemajo z i-to
          v vseh rkah razen na mestu Izp. }
        hc := Razprsi(i, Izp); i2 := Reze[hc];
        while i2 <> 0 do begin
          if Enaki(i, i2, Izp) then begin
            { i2 je res soseda besede 1. }
            if Prehod = 2 then begin { dodajmo ju v seznam sosed }
              Sosede[d]^[PrvaSoseda[i] + StSosed[i]] := i2;
              Sosede[d]^[PrvaSoseda[i2] + StSosed[i2]] := i;
            end; {if Prehod = 2}
            StSosed[i] := StSosed[i] + 1; StSosed[i2] := StSosed[i2] + 1;
          end; {if Enaki}
          i2 := Verige[i2]; { naprej po seznamu besed z razprilno kodo hc }
        end; {while}
        { Dodajmo e besedo i v razpreno tabelo. }
        Verige[i] := Reze[hc]; Reze[hc] := i;
      end; {for i}
    end; {for d, Izp}
    if Prehod = 1 then begin
      for d := MinDolz to MaxDolz do SkupajSosed[d] := 0;
      for i := 1 to N do begin
        PrvaSoseda[i] := SkupajSosed[Dolzina[i]] + 1;
        SkupajSosed[Dolzina[i]] := SkupajSosed[Dolzina[i]] + StSosed[i];
      end; {for i}
      for d := MinDolz to MaxDolz do if SkupajSosed[d] > 0 then
        GetMem(Sosede[d], SkupajSosed[d] * SizeOf(integer));
    end; {if Prehod = 1}
  end; {for Prehod}
  { Pomeimo zdaj vse besede v razpreno tabelo, 
    da jih bomo pri odgovarjanju na poizvedbe laje nali. }
  for i := 0 to RazpMax - 1 do Reze[i] := 0;
  for i := 1 to N do begin Verige[i] := 0; Obiskana[i] := 0; end; 
  for i := 1 to N do 
    begin hc := Razprsi(i, 0); Verige[i] := Reze[hc]; Reze[hc] := i; end;
  { Zanimo iskati najkraje poti med danimi pari besed. 
    Iskane besede bomo pomono obravnavali pod tevilko 0. }
  PrvaCrka[0] := PrvaCrka[N] + Dolzina[N];
  if ParamCount > 1 then Assign(TT, ParamStr(2)) else Assign(TT, 'slovar.out'); 
  Rewrite(TT); ReadLn(T, StPrimerov);
  for j := 1 to StPrimerov do begin
    ReadLn(T, S); i := 1; while S[i] <> ' ' do i := i + 1;
    S1 := Copy(S, 1, i - 1); S2 := Copy(S, i + 1, Length(S) - i); 
    { Niza S1 in S2 poiimo v razpreni tabeli. }
    Dolzina[0] := Length(S1); for i := 1 to Length(S1) do Crke[PrvaCrka[0] + i - 1] := S1[i];
    iOd := Reze[Razprsi(0, 0)]; while not Enaki(0, iOd, 0) do iOd := Verige[iOd];
    Dolzina[0] := Length(S2); for i := 1 to Length(S2) do Crke[PrvaCrka[0] + i - 1] := S2[i];
    iDo := Reze[Razprsi(0, 0)]; while not Enaki(0, iDo, 0) do iDo := Verige[iDo];
    { Z iskanjem v irino iemo pot od besede iOd do besede iDo. }
    Obiskana[iOd] := j; Glava := 1; Rep := 2; Vrsta[Glava] := iOd; d := 0; dNasl := 2;
    while (Glava < Rep) and (Obiskana[iDo] < j) do begin
      if Glava = dNasl then begin d := d + 1; dNasl := Rep; end;
      i := Vrsta[Glava]; Glava := Glava + 1;
      { Dodajmo v vrsto i-jeve sosede, e jih nismo e kdaj prej. }
      for k := 1 to StSosed[i] do begin
        i2 := Sosede[Dolzina[i]]^[PrvaSoseda[i] + k - 1];
        if Obiskana[i2] = j then continue;
        Vrsta[Rep] := i2; Rep := Rep + 1; Obiskana[i2] := j;
      end; {for k}
    end; {while}
    { Zdaj smo ali nali pod to iDo ali pa preiskali vse, do esar se je dalo 
      iz iOd sploh priti (in ugotovili, da se do iDo ne da priti). }
    if Obiskana[iDo] = j then WriteLn(TT, d + 1)
    else WriteLn(TT, 'Ni prehoda');
  end; {for j}
  Close(T); Close(TT);
  for d := MinDolz to MaxDolz do if SkupajSosed[d] > 0 then
    FreeMem(Sosede[d], SkupajSosed[d] * SizeOf(integer));
end. {Slovar}
