program DvaKupaStevil; { RTK 2003.1.1 }

{ Zanemo z dvema praznina kupoma, nato pa gledamo tevila od
  vejih proti manjim in vsako odloimo na kup z manjo vsoto.
  e imata oba kupa enako vsoto, uporabimo prvi kup. }
procedure Razdeli1(N: integer); 
var i, Kup, Kam: integer; Vsota: array [1..2] of integer; 
begin 
  for Kup := 1 to 2 do begin 
    Write(Kup, '. kup:'); 
    Vsota[1] := 0; Vsota[2] := 0;
    for i := N downto 1 do begin
      if Vsota[1] <= Vsota[2] then Kam := 1 else Kam := 2; 
      Vsota[Kam] := Vsota[Kam] + i; 
      if Kam = Kup then Write(' ', i); 
    end; {for i} 
    WriteLn('    Vsota: ', Vsota[Kup]);
  end; {for Kup} 
end; {Razdeli1}

{ Ta reitev razdeli tevila 1..N na skupine po tiri,
  od zadnjega konca naprej: (N, N-1, N-2, N-3),
  (N-4, N-5, N-6, N-7), itd.  Nato dobi prvi kup od
  vsake etverice prvo in zadnje tevilo, drugi kup
  pa vmesni dve.  Dobimo enak razpored kot prejnja reitev. }
procedure Razdeli2(N: integer); 
var i, Vsota: integer; 
begin
  Write('1. kup: ', N); Vsota := N; i := N - 4; 
  while i >= 0 do begin 
    Write(' ', i + 1); if i > 0 then Write(' ', i); 
    Vsota := Vsota + i + (i + 1); i := i - 4; 
  end; {while}
  WriteLn('    Vsota: ', Vsota); 
  Write('2. kup:'); Vsota := 0; i := N - 2; 
  while i >= 0 do begin 
    Write(' ', i + 1); if i > 0 then Write(' ', i); 
    Vsota := Vsota + i + (i + 1); i := i - 4;
  end; {while}
  WriteLn('    Vsota: ', Vsota); 
end; {Razdeli2} 

{ Ta reitev pa najprej deli tevila izmenino na en in
  na drugi kup, tako da en kup dobiva liha tevila,
  drugi pa soda.  Potem polovico takih parov (j-1, j) 
  zamenjamo in s tem zbliamo vsoti obeh kupov. }
procedure Razdeli3(N: integer); 
var P, Vsota, i, j, Kup: integer; 
begin
  { e je N lih, se delamo, da imamo tevila od 0 do N 
    namesto od 1 do N, tako da jih bo vedno sodo mnogo.
    Vsak kup dobi polovico vseh tevil, torej P tevil. }
  P := (N + 1) div 2; 
  for Kup := 1 to 2 do begin 
    Write(Kup, '. kup:'); Vsota := 0; 
    for i := 1 to P do begin 
      { Prvi kup naj bo tisti, ki bi imel brez zamenjav 
        vejo vsoto.  Od vsakega para bi torej ta kup dobil 
        j, drugi pa j - 1.  e je N lih, se moramo delati, 
        da zanemo s parom (0, 1), sicer pa s parom (1, 2). }
      j := 2 * i - (N mod 2);  
      { tevilo, ki je v paru z j, je j - 1.  Tega moramo 
        uporabiti, e smo na drugem kupu ali pa e smo 
        izvedli pri tem paru zamenjavo (ne pa, e velja oboje!).
        Zamenjave se izvede pri polovici vseh kupov (zato imamo
        spodaj pogoj i <= P div 2). }
      if (Kup = 1) = (i <= P div 2) then j := j - 1; 
      { Izpiimo tevilo in ga dodajmo v vsoto. } 
      if j > 0 then Write(' ', j); Inc(Vsota, j); 
    end; {for i} 
    WriteLn('    Vsota: ', Vsota); 
  end; {for Kup} 
end; {Razdeli3} 

var N, Dummy: integer;
begin {DvaKupaStevil}
  if ParamCount >= 1 then begin
    Val(ParamStr(1), N, Dummy); WriteLn('N = ', N);
  end else begin 
    Write('Koliko tevil? '); ReadLn(N); 
  end; {if}
  WriteLn; WriteLn('Prvi postopek:');
  Razdeli1(N);
  WriteLn; WriteLn('Drugi postopek:');
  Razdeli2(N);
  WriteLn; WriteLn('Tretji postopek:');
  Razdeli3(N);
end. {DvaKupaStevil}
