program VodenjeProjektov; { RTK 2003.3.4 }
const MaxN = 1000; MaxM = 10000; 
type TabelaN = array[1..MaxN] of integer;
     TabelaM = array[1..MaxM] of integer;
var T: text; m, n, i, j, u, v, w, Glava, Rep: integer;
    InDeg, OutDeg, PrvaPred, PrvaNasl, Vrsta, VVrsti: ^TabelaN;
    Zac, Kon, Pred, Nasl: ^TabelaM; Zbrisi: boolean;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) 
  else Assign(T, 'projekti.in');
  Reset(T); ReadLn(T, n); ReadLn(T, m);
  
  { Preberimo seznam povezav.  i-ta povezava gre od
    toke Zac^[i] do Kon^[i]; iz toke i gre
    OutDeg^[i] povezav, vanj pa InDeg^[i] povezav. }
  New(InDeg); New(OutDeg); New(Zac); New(Kon);
  for u := 1 to n do 
    begin InDeg^[u] := 0; OutDeg^[u] := 0; end;
  for i := 1 to m do begin
    ReadLn(T, u, v); Zac^[i] := u; Kon^[i] := v; 
    Inc(OutDeg^[u]); Inc(InDeg^[v]);
  end; {for}
  Close(T); New(PrvaPred); New(PrvaNasl); New(Pred); New(Nasl);
  
  { Pripravimo sezname predhodnic in naslednic.  u-jeve predhodnice
    so Pred^[PrvaPred^[u]], ..., Pred^[PrvaPred^[i] + InDeg^[u] - 1].
    Na enak nain so organizirane tudi naslednice (Nasl, PrvaNasl). }
  PrvaPred^[1] := 1; PrvaNasl^[1] := 1; 
  for u := 2 to n do PrvaPred^[u] := PrvaPred^[u - 1] + InDeg^[u - 1];
  for u := 2 to n do PrvaNasl^[u] := PrvaNasl^[u - 1] + OutDeg^[u - 1];
  for u := 1 to n do begin InDeg^[u] := 0; OutDeg^[u] := 0; end;
  for i := 1 to m do begin
    u := Zac^[i]; v := Kon^[i]; 
    Nasl^[PrvaNasl^[u] + OutDeg^[u]] := v; Inc(OutDeg^[u]);
    Pred^[PrvaPred^[v] + InDeg^[v]] := u; Inc(InDeg^[v]);
  end; {for}
  Dispose(Zac); Dispose(Kon); New(Vrsta); New(VVrsti);
  
  { Preglejmo vsako toko. }
  if ParamCount >= 2 then Assign(T, ParamStr(2)) 
  else Assign(T, 'projekti.out'); 
  Rewrite(T);
  for u := 1 to n do VVrsti^[u] := 0;
  for u := 1 to n do begin

    { Kaj vse je dosegljivo iz u?  Uporabimo iskanje v irino;
      v vrsti bomo hranili toke, ki jih moramo e obiskati
      in pregledati njihove neposredne naslednice.  Vrsto 
      hranimo v tabeli Vrsta; uporabljene celice so Glava..Rep.
      Tabela VVrsti pove, katere toke so trenutno v vrsti.
      Da ni treba pri vsakem u inicializirati cele tabele 
      (postavljati vseh vrednosti v njej na false), je to raje
      kar tabela integerjev; e je v neki celici vrednost u,
      pomeni, da je tista toka zdajle res v vrsti, e pa je
      vrednost manja, tiste toke ni v vrsti. }
    Glava := 1; Rep := 1; Vrsta^[1] := u; VVrsti^[u] := u;
    while Glava <= Rep do begin
      v := Vrsta^[Glava]; Inc(Glava);
      for i := 1 to OutDeg^[v] do begin { Preglejmo v-jeve naslednice. }
        w := Nasl^[PrvaNasl^[v] + i - 1];
        if VVrsti^[w] <> u then { Dodajmo w v vrsto. }
          begin Inc(Rep); Vrsta^[Rep] := w; VVrsti^[w] := u; end;
      end; {for}
    end; {while}
    
    { Preglejmo vse u-jeve naslednice. }
    for i := 1 to OutDeg^[u] do begin
      v := Nasl^[PrvaNasl^[u] + i - 1]; Zbrisi := false;
      { Ali je kakna v-jeva predhodnica tudi dosegljiva iz u? 
        e je tako, pomeni, da obstaja od u do v neka dalja
        pot (prek te v-jeve predhodnice w), zato lahko 
        povezavo od u do v priporoimo za brisanje. }
      for j := 1 to InDeg^[v] do begin
        w := Pred^[PrvaPred^[v] + j - 1];
        if (VVrsti^[w] = u) and (w <> u) then
          begin Zbrisi := true; break; end;
      end; {for j}
      if Zbrisi then WriteLn(T, u, ' ', v);
    end; {for i}
  end; {for u}
  
  Close(T);
  Dispose(Vrsta); Dispose(VVrsti); Dispose(Nasl); Dispose(Pred);
  Dispose(PrvaNasl); Dispose(PrvaPred);
end. {VodenjeProjektov}
