program TopovskeKrogle; { RTK 2004.2.2 }

function Min(a, b: integer): integer;
  begin if a < b then Min := a else Min := b end;

{ Raunska reitev. }
function StKrogel(p, s, v: integer): integer;
var MaxKL, MaxKD, k, N: integer;
begin
  if s = 1 then begin StKrogel := v; exit end;
  MaxKL := p - 1 + (v - 1) div 2;
  MaxKD := (s - p) + (v - 1) div 2;
  if (v mod 2 = 0) and (p = s) then MaxKD := MaxKD + 1;
  
  if MaxKL > MaxKD then MaxKL := MaxKD
  else if MaxKL < MaxKD then MaxKD := MaxKL + 1;

  N := 0;
  for k := 0 to Min(p - 1, MaxKL) do N := N + 2 * k + 1;
  if MaxKL >= p then N := N + (MaxKL - p + 1) * (2 * p - 1);
  if (v mod 2 = 0) and (p = s) then 
    N := N - 1; { L_MaxKL je nepopolna -- zadnja krogla se zvali cez rob. }

  for k := 1 to Min(s - p, MaxKD) do N := N + 2 * k;
  if MaxKD > s - p then N := N + (MaxKD - (s - p)) * 2 * (s - p);
  StKrogel := N;
end; {StKrogel}

{ Reitev s simulacijo. }
function StKrogel2(p, s, v: integer): integer;
const MaxS = 100;
var 
  Visina: array[0..2 * MaxS] of integer;
  x, A, B, C, BB, N: integer;
begin
  for x := 0 to 2 * s do if Odd(x) then Visina[x] := -1 else Visina[x] := 0;
  N := 0;
  while true do begin
    {Write(N + 1, '. krogla, globine ='); for x := 0 to 2 * s do Write(' ', Visina[x]); WriteLn;}
    x := 2 * p - 1;
    while (x > 0) and (x < 2 * s) do begin
      { B naj bo viina krogel na poloaju x, A in C pa na sosednjih
        dveh poloajih.  BB naj bo viina krogel na poloaju x, e
        bi trenutna krogla le e padla dol pri x in se ne bi ve
        premikala levo ali desno. }
      A := Visina[x - 1]; B := Visina[x]; C := Visina[x + 1];
      BB := B; if A > BB then BB := A; if C > BB then BB := C; BB := BB + 1;
      {WriteLn('x = ', x, ', (', A, ' ', B, ' ', C, ') ', BB);}
      { Premik na desno je mogo, e je B > C in se krogla ne bi odbila
        od desne stene.  Drugae razmislimo o razmiku v levo; e tudi
        to ne gre, se krogla pa ustavi. }
      if (B > C) and not ((x = 2 * s - 1) and (BB <= v)) then x := x + 1
      else if (B > A) and not ((x = 1) and (BB <= v)) then x := x - 1
      else break;
    end; {while}
    if (x <= 0) or (x >= 2 * s) then break; { Krogla je padla ez rob. }
    Visina[x] := BB; N := N + 1;
  end; {while}
  StKrogel2 := N;
  {WriteLn(N, ' =?= ', StKrogel(p, s, v)); Halt;}
  Assert(N = StKrogel(p, s, v));
end; {StKrogel2}

procedure Test(s, vMax: integer);
var v, p: integer;
begin
  WriteLn; WriteLn('s = ', s);
  for v := vMax downto 1 do begin
    Write('v = ', v, ': ');
    for p := 1 to s do Write(' ', StKrogel(p, s, v):2);
    Write('     ');
    for p := 1 to s do Write(' ', StKrogel2(p, s, v):2);
    WriteLn;
  end; {for v}
end; {Test}

begin {TopovskeKrogle}
  Test(6, 6);
  Test(5, 6);
  Test(4, 6);
  Test(3, 6);
  Test(2, 6);
  Test(1, 6);
end. {TopovskeKrogle}
